
#Title="naMCl"
#Ver="0.12.7.15"


XIncludeFile("StartMinecraft_Defs.pbi")

;------- todo


OpenPreferences(#title+".ini")

Global MCLOGINURL.s=ReadPreferenceString("MCLOGINURL","http://login.minecraft.net/?user=%1%&password=%2%&version=%3%")
Global MCLOGINVER.s=ReadPreferenceString("MCLOGINVER","99")
Global MCURL.s=ReadPreferenceString("MCURL","http://s3.amazonaws.com/MinecraftDownload/")
Global MCRESURL.s=ReadPreferenceString("MCRESURL","http://s3.amazonaws.com/MinecraftResources/")
Global MCASSETSURL.s=ReadPreferenceString("MCASSETSURL","http://assets.minecraft.net/")
Global CacheDir.s=ReadPreferenceString("CacheDir",GetCurrentDirectory()+"Cache\")
Global InstancesDir.s=ReadPreferenceString("InstancesDir",GetCurrentDirectory()+"Instances\")
Global VersionsDir.s=ReadPreferenceString("VersionsDir",GetCurrentDirectory()+"mcversions\")
Global ModDir.s=ReadPreferenceString("ModDir",GetCurrentDirectory()+"mods\")
Global PatchDir.s=ReadPreferenceString("PatchDir",GetCurrentDirectory()+"downgrade\")
Global MCWINClass.s=ReadPreferenceString("MCWINClass","SunAwtFrame")
Global MCWIName.s=ReadPreferenceString("MCWIName","Minecraft")
Global MCWINameLauncher.s=ReadPreferenceString("MCWINameLauncher","Minecraft Launcher")
Global MCWINameAltLauncher.s=ReadPreferenceString("MCWINameAltLauncher","Magic Launcher")
Global Winx=ReadPreferenceLong("WinX",-1)
Global Winy=ReadPreferenceLong("WinY",-1)
Global Winw=ReadPreferenceLong("WinW",640)
Global Winh=ReadPreferenceLong("WinH",480)
Global LatestVersion=ReadPreferenceLong("LatestVersion",0)
Global LatestVersionNr.s=ReadPreferenceString("LatestVersionNr","")
Global DefaultIconFile.s=ReadPreferenceString("DefaultIconFile",GetCurrentDirectory()+"Icons\Default.png")
ClosePreferences()

UseJPEGImageDecoder()
UseJPEG2000ImageDecoder()
UsePNGImageDecoder()
UseTGAImageDecoder()

Procedure IEGetFile(page.s,file.s); - Download a file from the internet 
  If URLDownloadToFile_(#Null,@page,@file,#Null,#Null) = #S_OK 
    ProcedureReturn #True 
  Else 
    ProcedureReturn #False 
  EndIf 
EndProcedure 




;-{ Init
;dll_Kernel=OpenLibrary(#PB_Any, "Kernel32.dll")
;If dll_Kernel
;  Prototype.l ProtoCreateHardLink(Link.p-unicode,Exist.p-unicode,Reserved.l = 0)
;  Global CreateHardLink.ProtoCreateHardLink = GetFunction(dll_Kernel, "CreateHardLinkW")
;Else
;  Debug "Kernel32.dll fehlt"
;  End
;EndIf

dll7zip=OpenLibrary(#PB_Any, "7-zip32.dll")

#FNAME_MAX32 = 512  
Structure INDIVIDUALINFO
  dwOriginalSize.l
  dwCompressedSize.l
  dwCRC.l
  uFlag.l
  uOSType.l
  wRatio.w
  wDate.w
  wTime.w
  szFileName.c[#FNAME_MAX32+1]
  dummy1.c[3]
  szAttribute.c[8]
  szMode.c[8]
EndStructure

If dll7zip
  Prototype.l ProtoSevenZip(hWnd.l, szCmdLine.l, stOutput.l, dwSize.l = 0)
  Global SevenZip.ProtoSevenzip = GetFunction(dll7zip, "SevenZip")
  
  Prototype.l ProtoSevenZipCheckArchive(szFileName.p-ascii, iMode.l = 0)
  Global SevenZipCheckArchive.ProtoSevenZipCheckArchive = GetFunction(dll7zip, "SevenZipCheckArchive")
  
  Prototype.l ProtoSevenZipOpenArchive(hWnd.l, szFileName.p-ascii, dwMode.l = 0)
  Global SevenZipOpenArchive.ProtoSevenZipOpenArchive = GetFunction(dll7zip,"SevenZipOpenArchive")
  
  Prototype.l ProtoSevenZipCloseArchive(HARC.l) 
  Global SevenZipCloseArchive.ProtoSevenZipCloseArchive = GetFunction(dll7zip,"SevenZipCloseArchive")
  
  Prototype.l ProtoSevenZipFindFirst(HARC.l, szWildName.p-ascii, *lpSubInfo.INDIVIDUALINFO) 
  Global SevenZipFindFirst.ProtoSevenZipFindFirst = GetFunction(dll7zip,"SevenZipFindFirst")
  
  Prototype.l ProtoSevenZipFindNext(HARC.l, *lpSubInfo.INDIVIDUALINFO)
  Global SevenZipFindNext.ProtoSevenZipFindNext = GetFunction(dll7zip,"SevenZipFindNext") 
Else
  Debug "7z fehlt"
  End
EndIf

;Wir bentigen unbedingt ein Win7z-Window
win7z=OpenWindow(#PB_Any,0,0,10,10,"7z",#PB_Window_Invisible)
While WindowEvent():Wend
Global win7zid=WindowID(win7z)
InitNetwork()

;}

;- Diverse Hilfsroutinen
Procedure.s CryptPass(*login.login)
  a$=*login\name+":"+*login\pass
  l=(Int((StringByteLength(a$)+2)/16)+2)*16  
  *memin=AllocateMemory(l*4+4)
  *memout=*memin+l+2
  *mem64=*memin+l*2+4;da oben immer auf die 32-Byte grere Grenze gerundet wird, immer grer 64
  For i=0 To l
    PokeB(*memin+i,Random(255))
  Next
  PokeS(*memin+2,a$)
  AESEncoder(*memin,*memout,l,?key,128,0,#PB_Cipher_ECB)
  l64=Base64Encoder(*memout,l,*mem64,l*2)
  b$=PeekS(*mem64,164)
  FreeMemory(*memin)
  ProcedureReturn b$
EndProcedure
Procedure DeCryptPass(a$,*login.login)
  L=Len(a$)
  *memin=AllocateMemory(l*2+4)
  *memout=*memin+l+2
  
  l64=Base64Decoder(@a$,l,*memin,l)
  AESDecoder(*memin,*memout,l64,?key,128,0,#PB_Cipher_ECB)
  
  b$=PeekS(*memout+2)
  FreeMemory(*memin)
  
  a=FindString(b$,":")
  *login\name=Left(b$,a-1)
  *login\pass=Right(b$,Len(b$)-a)

EndProcedure
Procedure.s CharToOem(a$)
  CharToOem_(a$,a$)
  ProcedureReturn a$
EndProcedure
Procedure.s GetJavaPath()
  pfad.s=GetEnvironmentVariable("ProgramW6432")
  If pfad.s=""
    pfad=GetEnvironmentVariable("ProgramFiles")
  EndIf
  pfad+"\java\"
  dir=ExamineDirectory(#PB_Any,pfad,"*.*")
  java$=""
  If dir
    While NextDirectoryEntry(dir)
      If DirectoryEntryType(dir)=#PB_DirectoryEntry_Directory
        a$=DirectoryEntryName(dir)
        If a$<>"." And a$<>".."
          If a$>java$
            java$=a$
          EndIf
        EndIf
      EndIf
    Wend
    FinishDirectory(dir)
  EndIf
  If java$
    ProcedureReturn pfad+java$+"\bin\"
  Else
    ProcedureReturn ""
  EndIf
EndProcedure
Procedure.s FindKey(a$,Find$,*key.long=0)
  If *key=0
    *key=@hiddenkey.l
  EndIf
  *key\l=FindString(a$,"<"+Find$+">",*key\l+1)
  If *key\l
    endkey=FindString(a$,"</"+Find$+">",*key\l)
    key$=Mid(a$,*key\l+Len(Find$)+2,endkey-*key\l-Len(Find$)-2)  
  EndIf
  ProcedureReturn key$
  
EndProcedure
Procedure AddMessage(a$)
  LastMessage=a$
  Debug ">"+a$
EndProcedure
Procedure ErrorCheck(a)
  If a=#False
    MessageRequester(#title,lastmessage)
  EndIf
  ProcedureReturn a
EndProcedure
Procedure CreateTreeFile(dir$); Alle unterverzeichnisse erstellen - ohne den Dateinamen
  ReplaceString(dir$,"/","\",#PB_String_InPlace)
  Slash=0
  
  Repeat
    Slash=FindString(dir$,"\",slash+1)
    If slash=0
      Break
    EndIf
    l=nextchar-firstchar
    CreateDirectory(Left(dir$,slash-1))
  ForEver
  
  
EndProcedure
Procedure EndMessage(a$,b=#False)
  If b=#False
    addmessage(a$)
    End
  EndIf
  ProcedureReturn b
EndProcedure
Procedure.s CreateMCPath(name.s)
  re$=Hex(Date())+" - "
  For i=1 To Len (name.s)
    c$=Mid(name,i,1)
    If FindString("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789[]()!.,-_#+",c$)>0
      re$+c$
    Else
      re$+"_"
    EndIf
  Next
  ProcedureReturn re$
EndProcedure
Procedure.s GetTag(*pos.long)
  deep=0:c34=0
  *buf.byte=*pos\l
  *start=*buf
  While *buf\b
    Select *buf\b
      Case '<'
        If c34=0
          If deep=0
            *start=*buf
          EndIf
          deep+1
        EndIf
      Case '>'
        If c34=0
          deep-1
          If deep=0
            *buf+1
            Break
          EndIf
          If deep<0
            *buf+1
            *start=*buf
            Break
          EndIf          
        EndIf
      Case 34
        c34=1-c34
    EndSelect
    *buf+1
  Wend
  *pos\l=*buf
  ProcedureReturn PeekS(*start,*buf-*start)
EndProcedure
Procedure.s getquote(a$) 
  a=FindString(a$,Chr(34))
  b=FindString(a$,Chr(34),a+1)
  If a And b
    b$=Mid(a$,a+1,b-a-1)
  EndIf
  ProcedureReturn b$
EndProcedure   
Procedure GetMaxDirDate(dir$)
  maxDate=0
  dir=ExamineDirectory(#PB_Any,dir$,"*.*")
  If dir
    While NextDirectoryEntry(dir)
      If DirectoryEntryType(dir)=#PB_DirectoryEntry_File
        If DirectoryEntryDate(dir,#PB_Date_Modified)>maxDate
          maxdate=DirectoryEntryDate(dir,#PB_Date_Modified)
        EndIf
      Else
        a$=DirectoryEntryName(dir)
        If a$<>"." And a$<>".."
          d=GetMaxDirDate(dir$+a$+"\")
          If d>maxdate
            maxdate=d
          EndIf            
        EndIf
      EndIf
    Wend
    FinishDirectory(dir)
  EndIf
  ProcedureReturn maxdate
EndProcedure
;- IconList-Handling
Global ELIS_newil,ELIS_iconw,ELIS_iconh
Procedure ChangeListIconSize(gadget,iconw=48,iconh=48)
  ELIS_newil = ImageList_Create_(iconW, iconH,  #ILC_COLOR32, 0, 20) 
  ELIS_iconh=iconh
  ELIS_iconw=iconw
  
  For i=0 To CountGadgetItems(gadget)-1
    *settings.instances=GetGadgetItemData(gadget,i)
    
    If ImageWidth(*settings\iconid)<>iconw Or ImageHeight(*settings\iconid)<>iconh
      im=CreateImage(#PB_Any,iconw,iconh,32)
      StartDrawing(ImageOutput(im))
      DrawImage(ImageID(*settings\iconid),0,0,iconw,iconh)
      StopDrawing()
      imageoff = ImageList_Add_(newIL,ImageID(im),0)
      FreeImage(im)
    Else
      imageoff = ImageList_Add_(newIL,ImageID(*settings\iconid),0)
    EndIf
       
    var.lvitem
    Var\mask = #LVIF_IMAGE 
    Var\iItem = i
    Var\iImage = imageoff
    
    SendMessage_(GadgetID(Gadget), #LVM_SETITEM, 0, @Var)
  Next  
  
  
  
  ;...Get handle to current ListIconGadget normal image list 
  oldIL = SendMessage_(GadgetID(gadget), #LVM_GETIMAGELIST, #LVSIL_NORMAL, 0) 
  ;...Replace the old image list with our new one 
  SendMessage_(GadgetID(gadget), #LVM_SETIMAGELIST, #LVSIL_NORMAL, newIL) 
  ;...Destroy the old image list 
  ;ImageList_Destroy_(oldIL) 
EndProcedure
Procedure EnableListIconSize(gadget,iconw,iconh) 
  ELIS_iconh=iconh
  ELIS_iconw=iconw
  ELIS_newil = ImageList_Create_(iconW, iconH,  #ILC_COLOR32, 0, 20) 
  ;...Get handle to current ListIconGadget normal image list 
  oldIL = SendMessage_(GadgetID(gadget), #LVM_GETIMAGELIST, #LVSIL_NORMAL, 0) 
  ;...Replace the old image list with our new one 
  SendMessage_(GadgetID(gadget), #LVM_SETIMAGELIST, #LVSIL_NORMAL, ELIS_newil) 
  ;...Destroy the old image list 
  ImageList_Destroy_(oldIL) 
EndProcedure
Procedure AddGadgetItemDat(gadget,pos,text$,dat)
  cgi=CountGadgetItems(gadget)
  If pos<0 Or pos>cgi
    pos=CountGadgetItems(gadget)
  EndIf
  AddGadgetItem(gadget,pos,text$)
  SetGadgetItemData(gadget,pos,dat)
EndProcedure
Procedure AddGadgetItemEx(gadget,pos,text$,dat,imagenr,imageindex=0)
  cgi=CountGadgetItems(gadget)
  If pos<0 Or pos>cgi
    pos=CountGadgetItems(gadget)
  EndIf
  AddGadgetItem(gadget,pos,text$)
  SetGadgetItemData(gadget,pos,dat)
  
  If imagenr<>0
    If ImageWidth(imagenr)<>ELIS_iconw Or ImageHeight(imagenr)<>ELIS_iconh
      im=CreateImage(#PB_Any,ELIS_iconw,ELIS_iconh,32)
      StartDrawing(ImageOutput(im))
      DrawImage(ImageID(imagenr),0,0,ELIS_iconw,ELIS_iconh)
      StopDrawing()
      imageoff = ImageList_Add_(ELIS_newil,ImageID(im),0)
      FreeImage(im)
    Else
      imageoff = ImageList_Add_(ELIS_newil,ImageID(imagenr),0)
    EndIf
  Else
    imageoff=imageindex
  EndIf
       
  var.lvitem
  Var\mask = #LVIF_IMAGE 
  Var\iItem = pos
  Var\iImage = imageoff
    
  SendMessage_(GadgetID(Gadget), #LVM_SETITEM, 0, @Var)
EndProcedure  
Procedure GetGadgetItemImageIndex(gadget,pos)
  var.lvitem
  Var\mask = #LVIF_IMAGE 
  Var\iItem = pos
  Var\iImage =0
    
  SendMessage_(GadgetID(Gadget), #LVM_GETITEM, 0, @Var)
  ProcedureReturn var\iImage
EndProcedure
Procedure SetGadgetItemIcon(gadget,nr,imagenr)
  HideGadget(gadget,#True)
  If ImageWidth(imagenr)<>ELIS_iconw Or ImageHeight(imagenr)<>ELIS_iconh
    im=CreateImage(#PB_Any,ELIS_iconw,ELIS_iconh,32)
    StartDrawing(ImageOutput(im))
    DrawImage(ImageID(imagenr),0,0,ELIS_iconw,ELIS_iconh)
    StopDrawing()
    imageoff = ImageList_Replace_(ELIS_newil,GetGadgetItemImageIndex(gadget,nr),ImageID(im),0)
    FreeImage(im)
  Else
    imageoff = ImageList_Replace_(ELIS_newil,GetGadgetItemImageIndex(gadget,nr),ImageID(imagenr),0)
  EndIf
  HideGadget(gadget,#False)
EndProcedure
;-
Procedure stampit(*settings.instances)
  MCDir.s=InstancesDir+*settings\path+"\.minecraft\"
  Debug mcdir+"magic\MagicLauncher.cfg"
  If FileSize(mcdir+"magic\MagicLauncher.cfg")>0
    temp.s=CurrentDir+"Temp\"
    
    in=ReadFile(#PB_Any,mcdir+"magic\MagicLauncher.cfg")
    If in
      config$=Space(Lof(in)+1)
      ReadData(in,@config$,Lof(in))
      CloseFile(in)
      a=FindString(config$,"<ActiveProfileIndex=")
      b=FindString(config$,">",a+8)
      Debug Str(a)+" "+Str(b)
      profile=Val( Mid(config$,a+20+1,b-a-20-2))
      start=-1
      ok=#True
      For i=0 To profile
        start=FindString(config$,"<Profile",start+1)
        If start=0:ok=#False:EndIf
      Next
      If ok
        pos=@config$+start-1
        profile$=gettag(@pos)
        pos=@profile$+1
        Repeat
          a$=gettag(@pos)
          If Left(a$,14)="<MinecraftJar="
            jar$=ReplaceString(getquote(a$),"\\","\")
          ElseIf Left(a$,6)="<Name="
            name$=getquote(a$)
          ElseIf Left(a$,4)="<Mod"
            inpos=@a$+1
            mod$="":active=#False
            Repeat
              ina$=gettag(@inpos)
              If Left(ina$,6)="<File="
                mod$=ReplaceString(getquote(ina$),"\\","\")
              ElseIf Left(ina$,8)="<Active="
                If getquote(ina$)="true"
                  active=#True
                EndIf
              Else
                Debug "--"+ina$
              EndIf
            Until ina$=""
            Debug "MOD:"+Str(active)+" "+mod$
            
            If mod$ And active
              cmd$="x "+Chr(34)+CharToOem(mod$)+Chr(34)+" -aoa -o"+Chr(34)+chartooem(temp)+Chr(34)+" -xr!meta-inf"
              ;Debug cmd$
              ret=SevenZip(WindowID(mainwindow), @cmd$, 0,0)
              If ret
                ok=#False
                addmessage("stampit: Can't unzip mod "+mod$)
              EndIf
            EndIf
            
          Else
            Debug "##"+a$
          EndIf
        Until a$="" Or ok=#False
        ;Jar kopieren, falls notwendig
        If ok
          If LCase(jar$)<>LCase(mcdir.s+"\bin\minecraft.jar")
            Debug "Copy jar"
            ok=CopyFile(jar$,mcdir.s+"\bin\minecraft.jar")
            Debug Str(a)
          EndIf
        EndIf
        ;so alles in die Jar packen
        If ok
          ;----
          cmd$="a "+Chr(34)+chartooem(mcdir.s+"\bin\minecraft.jar")+Chr(34)+" "+Chr(34)+chartooem(temp)+Chr(34)+" -r -mx9 -x!meta-inf"
          ret=SevenZip(WindowID(mainwindow), @cmd$, 0,0)
          If ret
            ok=#False
            addmessage("DownloadMinecraft: Can't patch minecraft.jar")
          EndIf
          If ok
            cmd$="d "+Chr(34)+chartooem(mcdir.s+"\bin\minecraft.jar")+Chr(34)+" META-INF "
            ret=SevenZip(WindowID(mainwindow), @cmd$, 0,0)
            If ret
              ok=#False
              addmessage("DownloadMinecraft: Can't patch minecraft.jar")
            EndIf
          EndIf
        
        EndIf
        If ErrorCheck(ok)
          MessageRequester(#title,"Profile "+name$+" patched!")
        EndIf
        
      EndIf
      DeleteDirectory(temp,"*.*",#PB_FileSystem_Recursive|#PB_FileSystem_Force)
    Else
      addmessage("stampit: Can't open Alternate-Config-File")
      errorcheck(#False)
    EndIf
    
  Else
    addmessage("Stamp: No Alternate-Config-File")
    errorcheck(#False)
  EndIf
EndProcedure
  
;- Instance-Routinen  
Procedure SaveInstanceSettings(*settings.instances,path.s="")
  If path=""
    path=*settings\path
  EndIf
  
  CreatePreferences(InstancesDir +path+"\settings.ini")
  WritePreferenceString("Name", *settings\name)
  ;WritePreferenceLong("Type", *settings\type)
  WritePreferenceString("MineCraftFile",*settings\MineCraftFile)
  WritePreferenceLong("SetMemory",*settings\setmemory)
  WritePreferenceLong("MinMemory",*settings\minmemory)
  WritePreferenceLong("MaxMemory",*settings\maxmemory)
  WritePreferenceLong("CustomJava",*settings\customjava)
  WritePreferenceString("JavaPath",*settings\javapath)
  WritePreferenceLong("Maximize",*settings\maximize)
  ;WritePreferenceLong("Update",*settings\Update)
  WritePreferenceLong("UseLauncher",*settings\UseLauncher)
  WritePreferenceString("AltLauncher",*settings\altlauncher)
  WritePreferenceString("LoginCrypt",*settings\LoginCrypt)
  WritePreferenceLong("AutoBackupSaves",*settings\AutoBackupSaves)
  WritePreferenceLong("BackupBeforUpdate",*settings\BackupBeforUpdate)
  WritePreferenceLong("AutoConnect",*settings\AutoConnect)
  WritePreferenceString("ConnectIP",*settings\ConnectIP)
  If *settings\minecraftfile=#server_beta
    WritePreferenceLong("BetaVersion",*settings\version)
  EndIf
  ClosePreferences()
  
  out=CreateFile(#PB_Any,InstancesDir +path+"\mods.ini")
  If out
    ForEach *settings\mods()
      WriteStringN(out,*settings\mods())
    Next
    CloseFile(out)
  EndIf
  
  If *settings\iconfile <> DefaultIconFile 
    If *settings\iconfile<>""
      DeleteFile(InstancesDir +path+"\icon.*")
      CopyFile(*settings\iconfile,InstancesDir +path+"\icon."+GetExtensionPart(*settings\iconfile))
    EndIf
  Else
    DeleteFile(InstancesDir +path+"\icon.*")
  EndIf
EndProcedure
Procedure LoadInstanceSettings(*settings.instances,path.s="")
  
  *settings\name="New "+FormatDate("%dd-%mm-%yyyy",Date())
  *settings\path=CreateMCPath(*settings\name)
  *settings\iconid=DefaultIconId
  ;*settings\Type=#server_release
  *settings\minecraftfile=#Server_Release
  *settings\setmemory=#False
  *settings\minmemory=512
  *settings\maxmemory=1024
  *settings\customjava=#False
  *settings\javapath=GetJavaPath()
  *settings\maximize=#False
  ;*settings\update=0
  *settings\Version=0
  *settings\altlauncher=""
  *settings\uselauncher=#launcher_int
  *settings\AutoBackupSaves=#False
  *settings\BackupBeforUpdate=#False
  *settings\LoginCrypt=""
  *settings\AutoConnect=0
  If path<>""
    *settings\path=path
    
    OpenPreferences(InstancesDir +path+"\settings.ini")
      update=ReadPreferenceLong("Update",-1)
      If update>-1
        Type=ReadPreferenceLong("Type",0)
        FirstElement(versions())
        If update=2
          *settings\minecraftfile=versions()\file
        ElseIf type=1
          *settings\minecraftfile=#server_beta  
        EndIf
      Else
        *settings\minecraftfile=ReadPreferenceString("MineCraftFile",*settings\minecraftfile)
      EndIf
    
      *settings\name=ReadPreferenceString("Name",path)
      *settings\setmemory=ReadPreferenceLong("SetMemory",*settings\setmemory)
      *settings\minmemory=ReadPreferenceLong("MinMemory",*settings\minmemory)
      *settings\maxmemory=ReadPreferenceLong("MaxMemory",*settings\maxmemory)
      *settings\customjava=ReadPreferenceLong("CustomJava",*settings\customjava)
      *settings\javapath=ReadPreferenceString("JavaPath",*settings\javapath)
      *settings\maximize=ReadPreferenceLong("Maximize",*settings\maximize)
      *settings\Uselauncher=ReadPreferenceLong("UseLauncher",*settings\UseLauncher)
      *settings\LoginCrypt=ReadPreferenceString("LoginCrypt",*settings\LoginCrypt)
      *settings\AltLauncher=ReadPreferenceString("AltLauncher",*settings\AltLauncher)
      *settings\AutoBackupSaves=ReadPreferenceLong("AutoBackupSaves",*settings\AutoBackupSaves)
      *settings\BackupBeforUpdate=ReadPreferenceLong("BackupBeforUpdate",*settings\BackupBeforUpdate)
      *settings\AutoConnect=ReadPreferenceLong("AutoConnect",*settings\AutoConnect)
      *settings\ConnectIP=ReadPreferenceString("ConnectIP",*settings\ConnectIP)
      If *settings\minecraftfile=#server_beta
        *settings\version=ReadPreferenceLong("BetaVersion",0)
      EndIf
    ClosePreferences()
      
    in=ReadFile(#PB_Any,InstancesDir +path+"\mods.ini")
    If in
      ClearList(*settings\mods())
      While Not Eof(in)
        AddElement(*settings\mods())
        *settings\mods()=ReadString(in)
      Wend
      CloseFile(in)
    EndIf
    
    If *settings\version=0
      in=ReadFile(#PB_Any,InstancesDir +path+"\.minecraft\bin\version")
      ;WriteString(out,Str(minecraftDate)+"000")
      If in
        ReadWord(in);2 bytes verwerfen
        a$=ReadString(in)
        CloseFile(in)
        *settings\version=Val(Left(a$,Len(a$)-3))
      EndIf
      
    EndIf
    
    a=LoadImage(#PB_Any,InstancesDir +path+"\icon.png")
    If a=0
      a=LoadImage(#PB_Any,InstancesDir +path+"\icon.bmp")
      If a=0
        a=LoadImage(#PB_Any,InstancesDir +path+"\icon.jpg")
      EndIf
    EndIf
    If a=0
      *settings\iconid=DefaultIconId
    Else
      *settings\iconid=a
    EndIf
  EndIf
EndProcedure
Procedure CopyInstanceSettings(*source.instances,*dest.instances)
  CopyStructure(*source,*dest,instances)
  *dest\iconid=CopyImage(*dest\iconid,#PB_Any)
EndProcedure
Procedure DestroyInstanceSettings(*source.instances)
  If IsImage(*source\iconid) And *source\iconid<>DefaultIconId
    FreeImage(*source\iconid)
  EndIf
EndProcedure  
Procedure insop_rebuildmods(List inmods.s(),gad_modins,gad_modava)
  ClearGadgetItems(gad_modins)
  ClearGadgetItems(gad_modava)
  ForEach mods()
    in=#False
    ForEach inmods()
      If inmods()=mods()\file
        in=#True
        Break
      EndIf
    Next
    If in=#False      
      AddGadgetItemdat(gad_modava,-1,"["+mods()\ver+"] "+mods()\name,@mods())
    EndIf
  Next
  
  ForEach inmods()
    in=#False
    ForEach Mods()
      If inmods()=mods()\file
        in=#True
        Break
      EndIf
    Next
    If in    
      AddGadgetItemdat(gad_modins,-1,"["+mods()\ver+"] "+mods()\name,@mods())
    EndIf
  Next
EndProcedure
  
Procedure insop_GadgetToList(gad_modins,List inmods.s())
  ClearList(inmods())
  c=CountGadgetItems(gad_modins)
  For i=0 To c-1
    AddElement(inmods())
    *mod.mods=GetGadgetItemData(gad_modins,i)
    inmods()=*mod\file
  Next
EndProcedure
Procedure InstanceOption(*settings.instances)
  DisableWindow(MainWindow,#True)
  
  ;iconid=CopyImage(*settings\iconid,#PB_Any)
  iconid=CreateImage(#PB_Any,48,48)
  StartDrawing(ImageOutput(iconid))
  DrawImage(ImageID(*settings\iconid),0,0,48,48)
  StopDrawing()
  iconfile.s=*settings\iconfile
  
  win_Option=OpenWindow(#PB_Any,0,0,600,400,"Instance Config",#PB_Window_WindowCentered|#PB_Window_SystemMenu,WindowID(mainwindow))
  
  
  
  gad_panel=PanelGadget(#PB_Any,5,5,WindowWidth(win_option)-10,WindowHeight(win_option)-5-20-10)
  
  AddGadgetItem(gad_panel,-1,"General")
  
  w=GetGadgetAttribute(gad_panel,#PB_Panel_ItemWidth)-100
  
  y=5
  
  TextGadget(#PB_Any,5,y,100,20,"Title")
  Gad_Name=StringGadget(#PB_Any,110,y,w-10-10,20,*settings\name)
  y+25
  
  TextGadget(#PB_Any,5,y,100,20,"Icon")
  Gad_Icon=ButtonImageGadget(#PB_Any,110,y,48+8,48+8,ImageID(iconid))
  y+48+8+5
  
  TextGadget(#PB_Any,5,y,100,20,"MineCraft Version")
  gad_Release=OptionGadget(#PB_Any,110,y,w-10-10,20,"Release"):y+20
  gad_Beta=OptionGadget(#PB_Any,110,y,w-10-10,20,"Beta / Weekly"):y+20
  gad_minecraftfile=OptionGadget(#PB_Any,110,y,20,20,"")
  gad_selectmcfile=ComboBoxGadget(#PB_Any,130,y,w-10-10-20,20):y+20
  y+5
    
  TextGadget(#PB_Any,5,y,100,20,"Backup")
  gad_AutoBackupSaves=CheckBoxGadget(#PB_Any,110,y,w-10-10,20,"Automatic Backup Saves"):y+20
  gad_BackupBeforUpdate=CheckBoxGadget(#PB_Any,110,y,w-10-10,20,"Backup before an update"):y+20
  y+5
  
  TextGadget(#PB_Any,5,y,100,20,"Launcher")
  gad_Launch_int=OptionGadget(#PB_Any,110,y,w-10-10,20,"use internal Launcher"):y+20
  gad_launch_mc =OptionGadget(#PB_Any,110,y,w-10-10,20,"use MineCraft Launcher"):y+20
  gad_Launch_alt=OptionGadget(#PB_Any,110,y,w-10-10,20,"use alternate Launcher"):y+20
  gad_altlauncher=StringGadget(#PB_Any,130,y,w-10-10-30-20,20,*settings\altlauncher,#PB_String_ReadOnly)
  gad_altlauncherbrow=ButtonGadget(#PB_Any,110+w-10-10-30,y,30,20,"..."):y+20
  gad_autologin=CheckBoxGadget(#PB_Any,110,y,w-10-10,20,"automatic login (internal only)"):y+20
  ;gad_AutoConnect=CheckBoxGadget(#PB_Any,110,y,w-10-10,20,"connect with server"):y+20
  ;gad_ConnectIP=StringGadget(#PB_Any,130,y,w-10-10-20,20,*settings\ConnectIP):y+20
  gad_maximize=CheckBoxGadget(#PB_Any,110,y,w-10-10,20,"Maximize window"):y+20
  y+5 
  
  AddGadgetItem(gad_panel,-1,"Java")
  y=5
  
  TextGadget(#PB_Any,5,y,100,20,"Memory")
  gad_setmemory=CheckBoxGadget(#PB_Any,110,y,w-10-10,20,"Set Memory Limits"):y+20
  TextGadget(#PB_Any,110,y,25,20,"Min:")
  gad_minmemory=StringGadget(#PB_Any,110+25,y,50,20,Str(*settings\minmemory),#PB_String_Numeric)
  TextGadget(#PB_Any,110+25+50,y,20,20,"MB")
  y+20
  TextGadget(#PB_Any,110,y,25,20,"Max:")
  gad_maxmemory=StringGadget(#PB_Any,110+25,y,50,20,Str(*settings\maxmemory),#PB_String_Numeric)
  TextGadget(#PB_Any,110+25+50,y,20,20,"MB")
  y+25
  
  TextGadget(#PB_Any,5,y,100,20,"Java-Version")
  gad_costumjava=CheckBoxGadget(#PB_Any,110,y,w-10-10,20,"Use this Java-Path:"):y+20
  gad_javapath=StringGadget(#PB_Any,110,y,w-10-10-30,20,*settings\javapath,#PB_String_ReadOnly)
  gad_javabrow=ButtonGadget(#PB_Any,110+w-10-10-30,y,30,20,"...")
  y+25
  
  AddGadgetItem(gad_panel,-1,"Modification")
  y=5
  w=GetGadgetAttribute(gad_panel,#PB_Panel_ItemWidth)/2
  
  ;TextGadget(#PB_Any,5,y,w-10,20,"Installed Mods",#PB_Text_Center|#PB_Text_Border)
  ;TextGadget(#PB_Any,w+2,y,w-10,20,"Available Mods",#PB_Text_Center|#PB_Text_Border):y+20
  h=GetGadgetAttribute(gad_panel,#PB_Panel_ItemHeight)-y-10
  ;gad_modins=ListViewGadget(#PB_Any,5,y,w-10,h)
  gad_modins=ListIconGadget(#PB_Any,5,y,w-10,h,"Installed Mods",w-40,#PB_ListIcon_FullRowSelect)
  ;gad_modava=ListViewGadget(#PB_Any,w+2,y,w-10,h)
  gad_modava=ListIconGadget(#PB_Any,w+2,y,w-10,h,"Available Mods",w-40,#PB_ListIcon_FullRowSelect)
  
  CloseGadgetList()
  
  y=WindowHeight(win_Option)-20-5 
  gad_ok=ButtonGadget(#PB_Any,5+WindowWidth(win_Option)/2-102,y,100,20,"OK")
  gad_cancel=ButtonGadget(#PB_Any,5+WindowWidth(win_Option)/2+2,y,100,20,"Cancel")
  
  insop_rebuildmods(*settings\mods(),gad_modins,gad_modava)
  
  ForEach versions()
    AddGadgetItem(gad_selectmcfile,-1,versions()\file)
  Next
  
  Select *settings\minecraftfile
    Case #server_release
      SetGadgetState(gad_Release,#True)
      SetGadgetState(gad_selectmcfile,0)
    Case #Server_Beta
      SetGadgetState(gad_beta,#True)
      SetGadgetState(gad_selectmcfile,0)
    Default
      SetGadgetState(gad_minecraftfile,#True)
      For i=0 To CountGadgetItems(gad_selectmcfile)-1
        If GetGadgetItemText(gad_selectmcfile,i)=*settings\minecraftfile
          SetGadgetState(gad_selectmcfile,i)
        EndIf
      Next 
  EndSelect
  
  
  
  ;If *settings\type=#Server_Release
  ;  SetGadgetState(gad_Release,#True)
  ;Else
  ;  SetGadgetState(gad_Beta,#True)
  ;EndIf
  
  SetGadgetState(gad_setmemory,*settings\setmemory)
  SetGadgetState(gad_costumjava,*settings\customjava)
  SetGadgetState(gad_maximize,*settings\maximize)
  SetGadgetState(gad_AutoBackupSaves,*settings\AutoBackupSaves)
  SetGadgetState(gad_BackupBeforUpdate,*settings\BackupBeforUpdate)

  EnableGadgetDrop(gad_modins,#PB_Drop_Private,#PB_Drag_Copy,2)
  EnableGadgetDrop(gad_modins,#PB_Drop_Private,#PB_Drag_Copy,3)
  EnableGadgetDrop(gad_modava,#PB_Drop_Private,#PB_Drag_Copy,2)
  EnableGadgetDrop(gad_modava,#PB_Drop_Files,#PB_Drag_Copy)
  EnableGadgetDrop(gad_modins,#PB_Drop_Files,#PB_Drag_Copy)
  
  
  If *settings\uselauncher=#launcher_int
    SetGadgetState(gad_Launch_int,#True)
  ElseIf *settings\uselauncher=#launcher_mc
    SetGadgetState(gad_launch_mc,#True)
  Else
    SetGadgetState(gad_Launch_alt,#True)
  EndIf
  
  Login$=*settings\LoginCrypt
  If login$
    SetGadgetState(gad_autologin,#True)
  EndIf
  
  NewList inmods.s()
  
  popup=CreatePopupMenu(#PB_Any)
  MenuItem(#menu_importmod,"Import mod")
  MenuItem(#menu_newmod,"New mod")
  
  
  Ret=#False
  Repeat
    event=WaitWindowEvent()
    Select event
      Case #PB_Event_Menu
        Select EventMenu()
          Case #menu_newmod
            state=lastrightclick
            insop_GadgetToList(gad_modins,inmods())
            file.s=newmod(win_Option)
            If file
              If state>-2
                If state=-1
                  LastElement(inmods())
                  AddElement(inmods())
                Else
                  SelectElement(inmods(),state)
                  InsertElement(inmods())
                EndIf                  
                inmods()=file
              EndIf
              scanmods()
              insop_rebuildmods(inmods(),gad_modins,gad_modava)
            EndIf
          Case #menu_importmod
            file.s=OpenFileRequester(#title+" - Import mod","","mod|*.zip;*.7z|all|*.*",1)
            If file
              
              state=lastrightclick
              insop_GadgetToList(gad_modins,inmods())
              file.s=importmod(file,win_Option)
              If file
                If state>-2
                  If state=-1
                    LastElement(inmods())
                    AddElement(inmods())
                  Else
                    SelectElement(inmods(),state)
                    InsertElement(inmods())
                  EndIf                  
                  inmods()=file
                EndIf
                scanmods()
                insop_rebuildmods(inmods(),gad_modins,gad_modava)
              EndIf   
            EndIf
                
        EndSelect
      Case #PB_Event_GadgetDrop
        Select EventGadget()
          Case gad_modava
            Select EventDropType()
              Case #PB_Drop_Private
                state=lastrightclick
                If state>-1
                  *mod.mods=GetGadgetItemData(gad_modins,state)
                  
                  c=CountGadgetItems(gad_modava):insert=0
                  For i=0 To c-1
                    *mod_ava.mods=GetGadgetItemData(gad_modava,i)
                    If *mod_Ava\sort<*mod\sort
                      insert=i+1
                    EndIf
                  Next

                  AddGadgetItemDat(gad_modava,insert,"["+*mod\ver+"] "+*mod\name,*mod)
                  RemoveGadgetItem(gad_modins,state)                  
                EndIf
              Case #PB_Drop_Files
                
                insop_GadgetToList(gad_modins,inmods())                
                
                If importmod(StringField(EventDropFiles(),1,Chr(10)),win_Option)
                  scanmods()
                  insop_rebuildmods(inmods(),gad_modins,gad_modava)
                EndIf
            EndSelect
          Case gad_modins
            Select EventDropType()
              Case #PB_Drop_Files
                state=GetGadgetState(gad_modins)
                insop_GadgetToList(gad_modins,inmods())
                file.s=importmod(StringField(EventDropFiles(),1,Chr(10)),win_Option)
                If file
                  If state=-1
                    LastElement(inmods())
                    AddElement(inmods())
                  Else
                    SelectElement(inmods(),state)
                    InsertElement(inmods())
                  EndIf                  
                  inmods()=file
                  scanmods()
                  insop_rebuildmods(inmods(),gad_modins,gad_modava)
                EndIf
              Case #PB_Drop_Private
                Select EventDropPrivate()
                  Case 3
                    state=lastrightclick
                    If state>-1
                      *mod.mods=GetGadgetItemData(gad_modava,state)
                      AddGadgetItemDat(gad_modins,GetGadgetState(gad_modins),"["+*mod\ver+"] "+*mod\name,*mod)
                      RemoveGadgetItem(gad_modava,state)
                    EndIf
                  Case 2
                    state=lastrightclick
                    If state>-1
                      newpos=GetGadgetState(gad_modins)
                      oldtext$=GetGadgetItemText(gad_modins,state)
                      olddat=GetGadgetItemData(gad_modins,state)
                      RemoveGadgetItem(gad_modins,state)
                      AddGadgetItemDat(gad_modins,newpos,oldtext$,olddat)
                      SetGadgetState(gad_modins,newpos)
                    EndIf
                EndSelect
            EndSelect
            
        EndSelect
      Case #PB_Event_Gadget
        Select EventType()
          Case #PB_EventType_RightClick
            Select EventGadget()
              Case gad_modava
                lastrightclick=-2
                DisplayPopupMenu(popup,WindowID(win_Option))
              Case gad_modins
                lastrightclick=GetGadgetState(gad_modins)
                DisplayPopupMenu(popup,WindowID(win_Option))
            EndSelect                
          Case #PB_EventType_DragStart
            Select EventGadget()
              Case gad_modava
                lastrightclick=GetGadgetState(gad_modava)
                DragPrivate(3,#PB_Drag_Copy)
              Case gad_modins
                lastrightclick=GetGadgetState(gad_modins)
                DragPrivate(2,#PB_Drag_Copy)
            EndSelect
          Case #PB_EventType_LeftDoubleClick
            Select EventGadget()
              Case gad_modava
                state=GetGadgetState(gad_modava)
                If state>-1
                  *mod.mods=GetGadgetItemData(gad_modava,state)
                  AddGadgetItemDat(gad_modins,-1,"["+*mod\ver+"] "+*mod\name,*mod)
                  RemoveGadgetItem(gad_modava,state)
                EndIf
              Case gad_modins
                state=GetGadgetState(gad_modins)
                If state>-1
                  *mod.mods=GetGadgetItemData(gad_modins,state)
                  
                  c=CountGadgetItems(gad_modava):insert=0
                  For i=0 To c-1
                    *mod_ava.mods=GetGadgetItemData(gad_modava,i)
                    If *mod_Ava\sort<*mod\sort
                      insert=i+1
                    EndIf
                  Next
                  AddGadgetItemDat(gad_modava,insert,"["+*mod\ver+"] "+*mod\name,*mod)
                  RemoveGadgetItem(gad_modins,state)
                  
                EndIf
            EndSelect            
          Case #PB_EventType_Change   
            Select EventGadget()
              Case gad_selectmcfile
                SetGadgetState(gad_minecraftfile,#True)
                SetGadgetState(gad_Release,#False)
                SetGadgetState(gad_Beta,#False)
            EndSelect
            
          Case #PB_EventType_LeftClick
            Select EventGadget()
              Case gad_autologin
                If GetGadgetState(gad_autologin)=#True
                  log.login
                  Debug login$
                  If login$
                    DeCryptPass(login$,log.login)
                  EndIf
                  If getlogin(win_Option,log)
                    login$=CryptPass(log)
                  Else
                    SetGadgetState(gad_autologin,#False)
                  EndIf
                EndIf
              Case gad_javabrow
                a$=OpenFileRequester("Select javaw.exe",GetGadgetText(gad_javapath),"javaw.exe|javaw.exe|all|*.*",0)
                If a$
                  SetGadgetText(gad_javapath,GetPathPart(a$))
                EndIf
              Case gad_altlauncherbrow
                a$=OpenFileRequester("Select alternate launcher",GetGadgetText(gad_altlauncher),"jar|*.jar|all|*.*",0)
                If a$
                  SetGadgetText(gad_altlauncher,a$)
                EndIf
              Case gad_icon
                If iconfile
                  a$=iconfile
                Else
                  a$="icons\"
                EndIf
                file$=OpenFileRequester("Select a Icon",a$,"Image (BMP,JPG,PNG)|*.bmp;*.jpg;*.png|All|*.*",0)
                If file$<>""
                  id=LoadImage(#PB_Any,file$)
                  If id
                    StartDrawing(ImageOutput(iconid))
                    DrawImage(ImageID(id),0,0,48,48)
                    StopDrawing()
                    SetGadgetAttribute(Gad_Icon,#PB_Button_Image,ImageID(iconid))
                    FreeImage(id)
                    iconfile=file$
                  Else
                    MessageRequester(#title,"Fileformat is not supported!"+Chr(10)+file$)
                  EndIf
                EndIf
                
              Case gad_ok
                ret=#True
                Break
              Case gad_cancel
                ret=#False
                Break
            EndSelect     
        EndSelect
    EndSelect 
    
  Until event=#PB_Event_CloseWindow
  If ret=#True
    If GetGadgetState(gad_Release)
      *settings\minecraftfile=#Server_Release
    ElseIf GetGadgetState(gad_beta)
      *settings\minecraftfile=#server_beta
    Else
      *settings\minecraftfile=GetGadgetText(gad_selectmcfile)
    EndIf
    
    
    If iconfile=*settings\iconfile
      FreeImage(iconid)
    Else
      If *settings\iconid<>DefaultIconID
        FreeImage(*settings\iconid)
      EndIf
      *settings\iconid=iconid
      *settings\iconfile=iconfile
    EndIf
    *settings\name=GetGadgetText(gad_name)

    *settings\setmemory=GetGadgetState(gad_setmemory)
    *settings\minmemory=Val(GetGadgetText(gad_minmemory))
    *settings\maxmemory=Val(GetGadgetText(gad_maxmemory))
    *settings\customjava=GetGadgetState(gad_costumjava)
    *settings\javapath=GetGadgetText(gad_javapath)
    *settings\maximize=GetGadgetState(gad_maximize)
    *settings\altlauncher=GetGadgetText(gad_altlauncher)
    *settings\AutoBackupSaves=GetGadgetState(gad_AutoBackupSaves)
    *settings\BackupBeforUpdate=GetGadgetState(gad_BackupBeforUpdate)
    ;*settings\AutoConnect=GetGadgetState(gad_AutoConnect)
    ;*settings\ConnectIP=GetGadgetText(gad_ConnectIP)
    
    If GetGadgetState(gad_Launch_alt)
      *settings\UseLauncher=#launcher_alt
    ElseIf GetGadgetState(gad_Launch_mc)
      *settings\UseLauncher=#launcher_mc
    Else
      *settings\UseLauncher=#launcher_int
    EndIf  
    If GetGadgetState(gad_autologin)
      *settings\LoginCrypt=login$
    Else
      *settings\LoginCrypt=""
    EndIf
    
    ClearList(*settings\mods())
    c=CountGadgetItems(gad_modins)
    For i=0 To c-1
      AddElement(*settings\mods())
      *mod.mods=GetGadgetItemData(gad_modins,i)
      *settings\mods()=*mod\file
    Next
    
  Else
    FreeImage(iconid)
  EndIf
  
  FreeMenu(popup)
  
  CloseWindow(win_Option)
  DisableWindow(MainWindow,#False)
  ProcedureReturn ret
EndProcedure
;- GUI-Kram
Procedure CB_Download(*list.CB_Download)
  *settings.instances=*list\instances
  
  *list\result=DownloadMinecraft(*settings\path,*list\forced,*settings\minecraftfile,*list\gad_text,*list\gad_time,*list\gad_progress)
  
  If *list\result
    Debug "Create Infos"
    If *settings\minecraftfile=#server_beta
      *settings\version=MineCraftBetaVersion
    Else
      *settings\version=MineCraftVersion
    EndIf
    SaveInstanceSettings(*settings)
  EndIf
  *list\finish=#True
EndProcedure
Procedure GUI_Download(*settings.instances,forced)
  DisableWindow(mainwindow,#True)
  win_DL=OpenWindow(#PB_Any,0,0,300,5+20+5+20+20+5+5,"Download",#PB_Window_WindowCentered,WindowID(mainwindow))
  
  
  para.CB_Download\instances=*settings
  para\gad_text=TextGadget(#PB_Any,5,5,290,20,"Gather information",#PB_Text_Center)
  para\gad_time=TextGadget(#PB_Any,5,30,290,20,"",#PB_Text_Center)
  para\gad_progress=ProgressBarGadget(#PB_Any,5,55,290,20,0,100)
  para\finish=#False
  para\forced=forced
  CreateThread(@CB_Download(),para)
  While Para\finish=#False
    WaitWindowEvent(100)
  Wend
  CloseWindow(win_dl)
  DisableWindow(mainwindow,#False)
  ProcedureReturn para\result
EndProcedure  
Procedure MineCraftBackup(*settings.instances)
  MCDir.s=InstancesDir+*settings\path+"\"
  
  SetCurrentDirectory(MCDir)
  cmd$="a "+Chr(34)+chartooem("backup\"+Str(Date())+" - "+*settings\path+".7z")+Chr(34)+" * -r -mx9 -x!backup"
  If SevenZip(WindowID(MainWindow), @cmd$, 0,0)=0
    ret=#True
  Else
    addmessage("MineCraftBackup: Can't backup.")
    ret=#False
  EndIf
  
  SetCurrentDirectory(CurrentDir)
  ProcedureReturn #True
EndProcedure
Procedure SaveBackup(*settings.instances)
  MCDir.s=InstancesDir+*settings\path+"\.minecraft\saves\"
  backup.s=InstancesDir+*settings\path+"\backup\"
  ret=#True
  dir=ExamineDirectory(#PB_Any,mcdir,"*.*")
  If dir
    While NextDirectoryEntry(dir)
      If DirectoryEntryType(dir)=#PB_DirectoryEntry_Directory
        a$=DirectoryEntryName(dir)
        If a$<>"." And a$<>".."
          maxdate=GetMaxDirDate(mcdir+a$+"\")
          CreateTreeFile(backup+a$+"\")
          OpenPreferences(backup+a$+"\lastupdate.ini")
          oldmax=ReadPreferenceLong("LastUpdate",0)
          ClosePreferences()
          If oldmax<maxDate
            
            SetCurrentDirectory(mcdir+a$+"\")
            b$=CharToOem(a$)
            cmd$="a "+Chr(34)+chartooem(backup+b$+"\"+Str(Date())+".7z")+Chr(34)+" * -r -mx9 -x!backup"
            If SevenZip(WindowID(MainWindow), @cmd$, 0,0)=0
              CreatePreferences(backup+a$+"\lastupdate.ini")
              WritePreferenceLong("LastUpdate",maxDate)
              ClosePreferences()
            Else
              addmessage("SaveBackup: Can't backup "+a$)
              ret=#False
            EndIf
            SetCurrentDirectory(CurrentDir)
            
            
          EndIf
          
        EndIf
      EndIf
    Wend
    FinishDirectory(dir)
  EndIf
  ProcedureReturn ret;--- check!
EndProcedure
Procedure cb_openinfowindow(dat)
  Repeat
    WaitWindowEvent()
  ForEver
EndProcedure
Procedure OpenInfoWindow(t1$,t2$,hideprogress=#False)
  If win_info=0
    DisableWindow(MainWindow,#True)
    win_info=OpenWindow(#PB_Any,0,0,300,5+20+5+20+20+5+5,#title,#PB_Window_WindowCentered,WindowID(mainwindow))
  
    gad_wininfo_t1=TextGadget(#PB_Any,5,5,290,20,t1$,#PB_Text_Center)
    gad_wininfo_t2=TextGadget(#PB_Any,5,30,290,20,t2$,#PB_Text_Center)
    gad_wininfo_progess=ProgressBarGadget(#PB_Any,5,55,290,20,0,100)
    HideGadget(gad_wininfo_progess,hideprogress)
    cb_wininfo_thread=CreateThread(@cb_openinfowindow(),0)
  Else
    SetGadgetText(gad_wininfo_t1,t1$)
    SetGadgetText(gad_wininfo_t2,t2$)
    HideGadget(gad_wininfo_progess,hideprogress)
  EndIf
  
    
EndProcedure
Procedure CloseInfoWindow()
  If win_info
    CloseWindow(win_info)
    KillThread(cb_wininfo_thread)
    win_info=0
    DisableWindow(MainWindow,#False)
  EndIf
EndProcedure
Procedure ResizeMainWindow(MainToolbar,Gadget_Panel,Gadget_Instances,Gadget_version,gadget_mods)
  ResizeGadget(Gadget_Panel,5,5,WindowWidth(Mainwindow)-10,WindowHeight(MainWindow)-10)
  w=GetGadgetAttribute(gadget_panel,#PB_Panel_ItemWidth )
  h=GetGadgetAttribute(gadget_panel,#PB_Panel_ItemHeight)
  
  HideGadget(Gadget_Instances,#True)
  ResizeGadget(Gadget_Instances,0,0,W,h)
  SetGadgetAttribute(Gadget_Instances, #PB_ListIcon_DisplayMode, #PB_ListIcon_SmallIcon)
  SetGadgetAttribute(Gadget_Instances, #PB_ListIcon_DisplayMode, #PB_ListIcon_LargeIcon)
  HideGadget(Gadget_Instances,#False)
  
  ResizeGadget(Gadget_version,0,0,W,h)
  ResizeGadget(Gadget_mods,0,0,W,h)
EndProcedure

XIncludeFile("minecraft_versions.pbi")
XIncludeFile("minecraft_mods.pbi")
XIncludeFile("minecraft_MCStuff.pbi")


;***
;-** INIT
;***

CreateTreeFile(CacheDir)
createtreefile(VersionsDir)

;-menu
For i=0 To 1
  If i=0
    instancesMenu=CreatePopupMenu(#PB_Any)
  Else
    instancesAltMenu=CreatePopupMenu(#PB_Any)
  EndIf
  MenuItem(#Menu_Name,"----")
  MenuItem(#Menu_Start,"Start")
  If i=1
    MenuItem(#menu_startAlt,"Start with alternate")
  EndIf
  MenuItem(#menu_Config,"Config")
  MenuBar()
  If i=1
    OpenSubMenu("Mod")
    MenuItem(#menu_Stamp,"Import Mod-Settings from alternate")
    CloseSubMenu()
  EndIf
  
  
  
  OpenSubMenu("Backup")
  MenuItem(#Menu_Backup,"Backup")
  CloseSubMenu()
  OpenSubMenu("Backup saves")
  MenuItem(#Menu_Backupsaves,"Backup saves")
  CloseSubMenu()
  
  OpenSubMenu("Repair/update")
  MenuItem(#Menu_Update,"Repair/Update")
  CloseSubMenu()
  
  OpenSubMenu("Clone")
  MenuItem(#Menu_Clone,"Clone")
  CloseSubMenu()
  
  OpenSubMenu("Delete")
  MenuItem(#Menu_delete,"Delete")
  CloseSubMenu()
  MenuBar()
  
  OpenSubMenu("Open in Explorer")
  MenuItem(#menu_openBrowser,"Instance")
  MenuItem(#menu_opensave,"Save")
  MenuItem(#menu_openscreen,"Screenshots")
  MenuItem(#menu_opentexture,"Texturepacks")
  CloseSubMenu()
  
Next

noinstancesMenu=CreatePopupMenu(#PB_Any)
MenuItem(#menu_new,"New instance")
MenuItem(#menu_import,"Import from original")


DisableMenuItem(instancesMenu,#Menu_Name,#True)
DisableMenuItem(instancesAltMenu,#Menu_Name,#True)


noversionsMenu=CreatePopupMenu(#PB_Any)
MenuItem(#menu_verreload,"Reload List")
MenuBar()
MenuItem(#menu_downloadbetas,"Download all Beta")

versionsMenu=CreatePopupMenu(#PB_Any)
MenuItem(#menu_downgrade,"Downgrade")
OpenSubMenu("Delete")
  MenuItem(#Menu_verdelete,"Delete")
CloseSubMenu()
  
nomodsMenu=CreatePopupMenu(#PB_Any)
MenuItem(#menu_newmod,"New mod")
MenuItem(#menu_importmod,"Import mod")

modsmenu=CreatePopupMenu(#PB_Any)
MenuItem(#menu_renamemod,"Rename")
MenuItem(#menu_openmod,"Open in Explorer")
OpenSubMenu("Delete")
  MenuItem(#Menu_deletemod,"Delete")
CloseSubMenu()
  

;-defaulticon laden
DefaultIconId=LoadImage(#PB_Any,DefaultIconFile)

;***
;-** Mainwindow
;***

If winx=-1 Or winy=-1
  Flag=#PB_Window_ScreenCentered
Else 
  Flag=0
EndIf

MainWindow=EndMessage("Can't open Window!",OpenWindow(#PB_Any,winx,winy,winw,winh,#title+" "+#ver,flag|#PB_Window_MaximizeGadget|#PB_Window_MinimizeGadget|#PB_Window_SystemMenu|#PB_Window_SizeGadget))

;MainToolbar=CreateToolBar(#PB_Any,WindowID(Mainwindow))
;ToolBarStandardButton(#menu_new,#PB_ToolBarIcon_New)
gadget_panel=PanelGadget(#PB_Any,0,0,100,100)

AddGadgetItem(gadget_panel,-1,"Instances")
  Gadget_Instances=ListIconGadget(#PB_Any,5,0,100,100,"Instances",100)
  
AddGadgetItem(gadget_panel,-1,"Minecraft Versions")
  gadget_versions=ListIconGadget(#PB_Any,0,0,100,100,"File",200,#PB_ListIcon_FullRowSelect|#PB_ListIcon_AlwaysShowSelection)  
  AddGadgetColumn(gadget_versions,1,"Version",150)
  AddGadgetColumn(gadget_versions,2,"Date",100)
  
AddGadgetItem(gadget_panel,-1,"Modifications")
  gadget_mods=ListIconGadget(#PB_Any,0,0,100,100,"Modification",200,#PB_ListIcon_FullRowSelect|#PB_ListIcon_AlwaysShowSelection)  
  AddGadgetColumn(gadget_mods,1,"MineCraft Version",200)
  
CloseGadgetList()


SetGadgetAttribute(Gadget_Instances, #PB_ListIcon_DisplayMode, #PB_ListIcon_LargeIcon)
EnableListIconSize(Gadget_Instances,48,48)
EnableGadgetDrop(Gadget_Instances, #PB_Drop_Private, #PB_Drag_Copy, 1)

EnableGadgetDrop(gadget_versions,#PB_Drop_Files,#PB_Drag_Copy)
EnableGadgetDrop(gadget_mods,#PB_Drop_Files,#PB_Drag_Copy)

ResizeMainWindow(MainToolbar,Gadget_panel,Gadget_Instances,gadget_versions,Gadget_mods)


;-Jeweils aktuellste version suchen
If GetMCFileList(MCURL+"?prefix=minecraft.jar","download_versions\")
  If findmcfile("minecraft.jar")
    MineCraftVersion=mcfilelist()\date
    Debug "minecraftversion:"+Str(MineCraftVersion)
  EndIf
EndIf
If GetMCFileList(MCASSETSURL,"assets\")
  minecraftjar.s="":maxDate=0
  ForEach mcfilelist()
    If Right(UCase("\"+mcfilelist()\file),14)="\MINECRAFT.JAR" And mcfilelist()\date>maxDate
      minecraftjar=mcfilelist()\file
      maxDate=MCFilelist()\date
    EndIf
  Next
  MineCraftBetaVersion=maxdate
  Debug "Betaversion:"+Str(MineCraftBetaVersion)
EndIf

;- aktuellste Version sichern
If LatestVersion<>MineCraftVersion Or LatestVersionNr=""
  If getmcfilelist(MCURL,"download\")
    Debug "aktuelle Version downloaden"
    If DownloadMCFile("minecraft.jar",CacheDir+"currentversion.jar")
      If DoDownloads()
        ver$=GetMineCraftVersion(CacheDir+"currentversion.jar",@date.l)
        RenameFile(cachedir+"currentversion.jar",VersionsDir+"minecraft - "+ver$+".jar")
        LatestVersion=MineCraftVersion
        latestversionnr=ver$
      EndIf
    EndIf
    DeleteFile(cachedir+"currentversion.jar")
  EndIf
EndIf

;- Versionen einfgen
ScanVersion()
rebuildVersion(gadget_versions)

;- Mods einfgen
scanmods()
rebuildmods(gadget_mods)

;-Instancen suchen
dir =ExamineDirectory(#PB_Any,InstancesDir,"*.*")
If dir
  While NextDirectoryEntry(dir)
    If DirectoryEntryType(dir)=#PB_DirectoryEntry_Directory
      folder$=DirectoryEntryName(dir)
      If folder$<>"." And folder$<>".."
        AddElement(instances())
        LoadInstanceSettings(instances(),folder$)
      EndIf
    EndIf
  Wend
  FinishDirectory(dir)
EndIf

;sortierung einfgen
in=ReadFile(#PB_Any,InstancesDir+"sort.ini")
If in
  While Not Eof(in)
    a$=ReadString(in)
    ForEach instances()
      If instances()\path=a$
        AddGadgetItemEx(Gadget_Instances,-1,instances()\name,@instances(),instances()\iconid)
        instances()\sorthelp=#True
      EndIf
    Next
  Wend
  CloseFile(in)
EndIf


;Restliche instances einfgen
ForEach instances()
  If instances()\sorthelp=#False
    AddGadgetItemEx(Gadget_Instances,-1,instances()\name,@instances(),instances()\iconid)
  EndIf
Next

;-Updates berprfen
updatetext$=""
ForEach instances()
  Select instances()\minecraftfile
    Case #server_release
      If instances()\version<>MineCraftVersion
        Debug "UPDATE:"+instances()\name
        ok=#True
        If instances()\BackupBeforUpdate
          If ErrorCheck(MineCraftBackup(instances()))=#False
            ok=#False
          EndIf
        EndIf
        If ok
          If ErrorCheck(GUI_Download(instances(),#False))
            updatetext$+instances()\name+" updated"+Chr(10)
          Else
            updatetext$+instances()\name+" update failed"+Chr(10)
          EndIf
        EndIf
      EndIf
    Case #server_beta
      If instances()\version<>MineCraftBetaVersion
        ok=#True
        If instances()\BackupBeforUpdate
          If ErrorCheck(MineCraftBackup(instances()))=#False
            ok=#False
          EndIf
        EndIf
        If ok
          If ErrorCheck(GUI_Download(instances(),#False))
            updatetext$+instances()\name+" updated (beta)"+Chr(10)
          Else
            updatetext$+instances()\name+" update failed (beta)"+Chr(10)
          EndIf
        EndIf
      EndIf
    Default
      If instances()\version<>MineCraftVersion
        Debug "updateversion"
        errorcheck(SaveVersion(InstancesDir+instances()\path+"\.minecraft\bin\version",MineCraftVersion))
        instances()\version=MineCraftVersion
      EndIf
  EndSelect
Next
  
If updatetext$<>""
  Debug "**"+updatetext$+"**"
  MessageRequester(#title,updatetext$)
EndIf


lastrightclick=-1
*rightclicksettings.instances
Repeat
  CheckMinecraft()
  event=WaitWindowEvent(200)
  Select event
    Case #PB_Event_Gadget;-gadgets
      Select EventType()
        Case #PB_EventType_RightClick;- Rechtsclick
          Select EventGadget()
            Case gadget_mods
              state=GetGadgetState(gadget_mods)
              If state>-1
                lastrightclick=state
                DisplayPopupMenu(modsmenu,WindowID(mainwindow))
              Else
                DisplayPopupMenu(nomodsMenu,WindowID(mainwindow))
              EndIf
            Case gadget_versions
              state=GetGadgetState(gadget_versions)
              If state>-1
                lastrightclick=state
                DisplayPopupMenu(versionsmenu,WindowID(mainwindow))
              Else
                DisplayPopupMenu(noversionsMenu,WindowID(mainwindow))
              EndIf
            Case Gadget_Instances
              state=GetGadgetState(Gadget_Instances)
              If state>-1
                lastrightclick=state
                *rightclicksettings=GetGadgetItemData(Gadget_Instances,state)
                If *rightclicksettings
                  If *rightclicksettings\altlauncher<>""
                    SetMenuItemText(instancesAltMenu,#menu_name,*rightclicksettings\name)
                    DisplayPopupMenu(instancesAltMenu,WindowID(MainWindow))
                  Else
                    SetMenuItemText(instancesMenu,#menu_name,*rightclicksettings\name)
                    DisplayPopupMenu(instancesMenu,WindowID(MainWindow))
                  EndIf
                EndIf
              Else
                DisplayPopupMenu(noinstancesMenu,WindowID(MainWindow))
              EndIf
          EndSelect
        Case #PB_EventType_LeftDoubleClick ;- doubleclick
          If EventGadget()=Gadget_Instances
            state=GetGadgetState(Gadget_Instances)
            *settings.instances=GetGadgetItemData(Gadget_Instances,state)
            If *settings
              ErrorCheck(StartMinecraft(*settings))
            EndIf
          EndIf
        Case #PB_EventType_DragStart ;- dragstart
          If EventGadget()=Gadget_Instances
            dragstart=GetGadgetState(Gadget_Instances)
            DragPrivate(1)
          EndIf
      EndSelect
    Case #PB_Event_GadgetDrop ;- drop
      Select EventGadget()
        Case gadget_mods
          importmod(StringField(EventDropFiles(),1,Chr(10)))
          scanmods()
          rebuildmods(gadget_mods)
        Case gadget_versions
          file.s=StringField(EventDropFiles(),1,Chr(10))
          If UCase(Right(file,4))<>".JAR"
            addmessage("Versions: No Jar file "+file)
            errorcheck(#False)
          Else
            ver$=GetMineCraftVersion( file,@date.l)
            If CopyFile(file,VersionsDir+"minecraft - "+ver$+".jar")
              appendversionsini("minecraft - "+ver$+".jar",date,ver$)
              ScanVersion()
              RebuildVersion(gadget_versions)
            Else
              addmessage("Versions: File already exist: minecraft - "+ver$+".jar")
              errorcheck(#False)
            EndIf
          EndIf

        Case Gadget_Instances
          dragend=GetGadgetState(Gadget_Instances)
          If dragend<>-1 And dragstart<>dragend
            If dragend>dragstart
              ;drageend-1
              Debug "**"
            EndIf
            
            
            a$=GetGadgetItemText(Gadget_Instances,dragstart)
            dat=GetGadgetItemData(Gadget_Instances,dragstart)
            iindex=GetGadgetItemImageIndex(Gadget_Instances,dragstart)
            
            ;Durch einen bug muss man den Displaymode unntig einmal ndern
            HideGadget(Gadget_Instances,#True)
            SetGadgetAttribute(Gadget_Instances, #PB_ListIcon_DisplayMode, #PB_ListIcon_SmallIcon)
            RemoveGadgetItem(Gadget_Instances,dragstart)
            AddGadgetItemex(Gadget_Instances,dragend,a$,dat,0,iindex)
            SetGadgetAttribute(Gadget_Instances, #PB_ListIcon_DisplayMode, #PB_ListIcon_LargeIcon)
            HideGadget(Gadget_Instances,#False)  
            SetActiveGadget(Gadget_Instances)
            SetGadgetItemState(Gadget_Instances,dragend,#True)
            
          EndIf

      EndSelect
    Case #PB_Event_SizeWindow ;- resiize
      ResizeMainWindow(MainToolbar,Gadget_panel,Gadget_Instances,gadget_versions,Gadget_mods)
    Case #PB_Event_Menu;- Menus
      Select EventMenu()
        Case #menu_openmod
          SelectElement(mods(),lastrightclick)
          RunProgram(mods()\file)
        Case #menu_renamemod
          SelectElement(mods(),lastrightclick)
          a$=InputRequester(#title,"rename mod",mods()\name)
          If a$
            mods()\name=a$
            savemodini(mods())
            rebuildmods(gadget_mods)
          EndIf
        Case #menu_deletemod
          SelectElement(mods(),lastrightclick)
          RemoveGadgetItem(gadget_mods,lastrightclick)
          DeleteDirectory(mods()\file,"*.*",#PB_FileSystem_Force|#PB_FileSystem_Recursive)
          DeleteElement(mods())
        Case #menu_newmod
          newmod()
          Scanmods()
          rebuildmods(gadget_mods)          
        Case #menu_importmod
          file.s=OpenFileRequester(#title+" - Import mod","","mod|*.zip;*.rar;*.7z|all|*.*",1)
          If file
            importmod(file)
            Scanmods()
          rebuildmods(gadget_mods)
          EndIf
        Case #Menu_verdelete
          file.s=versionsdir+GetGadgetItemText(gadget_versions,lastrightclick)
          DeleteFile(file)
          ScanVersion()
          RebuildVersion(gadget_versions)
        Case #menu_verreload
          ScanVersion()
          RebuildVersion(gadget_versions)
        Case #menu_downgrade
          infile.s=versionsdir+GetGadgetItemText(gadget_versions,lastrightclick)
          OpenInfoWindow("Downgrade","",#True)
          tempdir.s=CacheDir+"\patch\"
          CreateTreeFile(tempdir)
          downgrade(infile,tempdir,gad_wininfo_t2,#True)          
          DeleteDirectory(tempdir,"*.*",#PB_FileSystem_Recursive|#PB_FileSystem_Force)
          CloseInfoWindow()
          ScanVersion()
          RebuildVersion(gadget_versions)
        Case #menu_downloadbetas
          If GetMCFileList(MCASSETSURL,"assets\")
            i=-1
            OpenInfoWindow("Download Betas","")
            ForEach mcfilelist()
              If Right(UCase("\"+mcfilelist()\file),14)="\MINECRAFT.JAR"
                ;Debug "minecraft - "+StringField(mcfilelist()\file,1,"\")+".jar"
                i+1
                DownloadMCFile(cachedir+"downloadbeta"+Str(i)+".jar")
              EndIf
            Next
            
            DoDownloads(gad_wininfo_t1,gad_wininfo_t2,gad_wininfo_progress)
            
            For a=0 To i
              ver$=GetMineCraftVersion(cachedir+"downloadbeta"+Str(a)+".jar",@date)
              If date<>0
               
                If RenameFile(cachedir+"downloadbeta"+Str(a)+".jar",VersionsDir+"minecraft - "+ver$+".jar")
                  Debug "OK "+ver$+" "+Str(date)
                  AppendVersionsIni("minecraft - "+ver$+".jar",date,ver$)
                EndIf
              EndIf
              DeleteFile(cachedir+"downloadbeta"+Str(a)+".jar")
            Next
            CloseInfoWindow()
            ScanVersion()
            RebuildVersion(gadget_versions)
            
          EndIf
        Case #Menu_Update
          ok=#True
          If *rightclicksettings\BackupBeforUpdate
            If ErrorCheck(MineCraftBackup(*rightclicksettings))=#False
              ok=#False
            EndIf
          EndIf
          If ok
            removemods(*rightclicksettings)
            ErrorCheck(GUI_Download(*rightclicksettings,#True))
            installmod(*rightclicksettings,#True)
          EndIf
        Case #menu_Config
          newinstances.instances
          CopyInstanceSettings(*rightclicksettings,newinstances)
          If InstanceOption(newinstances)
            If *rightclicksettings\name<>newinstances\name
              SetGadgetItemText(Gadget_Instances,lastrightclick,newinstances\name)
            EndIf
            If *rightclicksettings\iconid<>newinstances\iconid
              SetGadgetItemIcon(Gadget_Instances,lastrightclick,newinstances\iconid)
            EndIf
            
            ok=#True
            If *rightclicksettings\minecraftFile<>newinstances\minecraftFile
              ok=#False
            ElseIf ListSize(*rightclicksettings\mods())<>ListSize(newinstances\mods())
              ok=#False
            Else
              ResetList(newinstances\mods())
              ForEach *rightclicksettings\mods()
                NextElement(newinstances\mods())
                If *rightclicksettings\mods()<>newinstances\mods()
                  ok=#False
                EndIf
              Next
            EndIf
            
            If CountGadgetItems(gadget_mods)<>ListSize(mods())
              rebuildmods(gadget_mods)
            EndIf
            
            CopyInstanceSettings(newinstances,*rightclicksettings)
            SaveInstanceSettings(*rightclicksettings)
            SetActiveGadget(Gadget_Instances)
            SetGadgetItemState(Gadget_Instances,lastrightclick,#True)
            
            If ok
              Debug "unchanged"
            Else
              Debug "changed!"
              GUI_Download(*rightclicksettings,#False)
              installmod(*rightclicksettings,#False)

            EndIf
            
            
          EndIf
          DestroyInstanceSettings(newinstances)
        Case #Menu_Start
          ErrorCheck(StartMinecraft(*rightclicksettings))
        Case #menu_StartAlt
          If *rightclicksettings\uselauncher=#launcher_alt
            *rightclicksettings\uselauncher=#launcher_int
            ErrorCheck(StartMinecraft(*rightclicksettings))
            *rightclicksettings\uselauncher=#launcher_alt
          Else
            altlaunch=*rightclicksettings\uselauncher
            *rightclicksettings\uselauncher=#launcher_alt
            ErrorCheck(StartMinecraft(*rightclicksettings))
            *rightclicksettings\uselauncher=altlaunch
          EndIf
        Case #menu_new  
          LoadInstanceSettings(newInstances.instances)
          If InstanceOption(newInstances)
            Debug "OK, neu erstellen"
            Debug newInstances\Name
            newinstances\path=CreateMCPath(newInstances\name)
            If ErrorCheck( GUI_Download(newinstances,#True))
              installmod(newinstances,#True)
              AddElement(instances())
              CopyInstanceSettings(newInstances,instances())
              addgadgetitemex(Gadget_Instances,-1,instances()\name,@instances(),instances()\iconid)
              ;AddGadgetIteme(Gadget_Instances,-1,newInstances\name,ImageID(newInstances\iconid))
            EndIf
          EndIf
          DestroyInstanceSettings(newinstances)
        Case #menu_import
          LoadInstanceSettings(newinstances.instances)
          newinstances\name="Imported"
          If InstanceOption(newInstances)
            OpenInfoWindow("Import original installation","",#True)
            
            newinstances\path=CreateMCPath(newInstances\name)
            MCDir.s=InstancesDir+newinstances\path+"\.minecraft\"
            CreateTreeFile(mcdir)
            If errorcheck(CopyDirectory(appdata+"\.minecraft",mcdir,"*.*",#PB_FileSystem_Recursive|#PB_FileSystem_Force))
              If GetMCFileList(MCURL,"download\")
                DownloadMCFile("launcher\MinecraftLauncher.jar",mcdir+"bin\MinecraftLauncher.jar")
                dodownloads()
              EndIf
              AddElement(instances())
              CopyInstanceSettings(newInstances,instances())
              addgadgetitemex(Gadget_Instances,-1,instances()\name,@instances(),instances()\iconid)
              SaveInstanceSettings(instances())
            EndIf            
            
            CloseInfoWindow()
          EndIf
        Case #menu_clone
          CopyInstanceSettings(*rightclicksettings,newinstances.instances)
          newinstances\name+" - copy"
          If InstanceOption(newInstances)
            OpenInfoWindow("Clone instance",newinstances\name,#True)
            newinstances\path=CreateMCPath(newInstances\name)
            MCDir.s=InstancesDir+newinstances\path+"\.minecraft\"
            CreateTreeFile(mcdir)
            If errorcheck(CopyDirectory(InstancesDir+*rightclicksettings\path+"\.minecraft\",mcdir,"*.*",#PB_FileSystem_Recursive|#PB_FileSystem_Force))
              AddElement(instances())
              CopyInstanceSettings(newInstances,instances())
              addgadgetitemex(Gadget_Instances,-1,instances()\name,@instances(),instances()\iconid)
              SaveInstanceSettings(instances())
            EndIf 
            CloseInfoWindow()
          EndIf
          DestroyInstanceSettings(newinstances)
        Case #menu_delete
          ;HideGadget(Gadget_Instances,#True)
          RemoveGadgetItem(Gadget_Instances,lastrightclick)
          ChangeCurrentElement(instances(),*rightclicksettings)
          DeleteDirectory(InstancesDir+ *rightclicksettings\path,"*.*",#PB_FileSystem_Recursive|#PB_FileSystem_Force)
          
          DestroyInstanceSettings(*rightclicksettings)
          DeleteElement(instances())
          
          ;HideGadget(Gadget_Instances,#False)
          ;SetActiveGadget(Gadget_Instances)
          ;SetGadgetItemState(Gadget_Instances,dragend,#True)
        Case #menu_openBrowser
          RunProgram(InstancesDir+ *rightclicksettings\path)
        Case #menu_opensave
          RunProgram(InstancesDir+ *rightclicksettings\path+"\.minecraft\saves")
        Case #menu_openscreen
          RunProgram(InstancesDir+ *rightclicksettings\path+"\.minecraft\screenshots")
        Case #menu_opentexture
          RunProgram(InstancesDir+ *rightclicksettings\path+"\.minecraft\texturepacks")
        Case #menu_backup
          errorcheck(MineCraftBackup(*rightclicksettings))
        Case #Menu_Backupsaves
          errorcheck(saveBackup(*rightclicksettings))
        Case #menu_stamp
          stampit(*rightclicksettings)
          
      EndSelect
      
  EndSelect 
  
Until event=#PB_Event_CloseWindow

;Sortierung der Instances schreiben
out=CreateFile(#PB_Any,InstancesDir+"sort.ini")
If out
  For i=0 To CountGadgetItems(Gadget_Instances)
    *settings.instances=GetGadgetItemData(Gadget_Instances,i)
    If *settings
      WriteStringN(out,*settings\path)
    EndIf
  Next
  CloseFile(out)
EndIf

CreatePreferences(#title+".ini")

WritePreferenceString("MCLOGINURL",MCLOGINURL)
WritePreferenceString("MCLOGINVER",MCLOGINVER)
WritePreferenceString("MCURL",MCURL)
WritePreferenceString("MCRESURL",MCRESURL)
WritePreferenceString("MCASSETSURL",MCASSETSURL)
WritePreferenceString("CacheDir",CacheDir)
WritePreferenceString("InstancesDir",InstancesDir)
WritePreferenceString("VersionsDir",VersionsDir)
WritePreferenceString("ModDir",ModDir)
WritePreferenceString("MCWINClass",MCWINClass)
WritePreferenceString("MCWIName",MCWIName)
WritePreferenceString("MCWINameLauncher",MCWINameLauncher)
WritePreferenceString("MCWINameAltLauncher",MCWINameAltLauncher)
WritePreferenceString("PatchDir",PatchDir)
WritePreferenceLong("WinX",WindowX(mainwindow))
WritePreferenceLong("WinY",WindowY(mainwindow))
WritePreferenceLong("WinW",WindowWidth(mainwindow))
WritePreferenceLong("WinH",WindowHeight(mainwindow))
WritePreferenceString("DefaultIconFile",DefaultIconFile)
WritePreferenceLong("LatestVersion",LatestVersion)
WritePreferenceString("LatestVersionNr",LatestVersionNr)
ClosePreferences()


End

CloseLibrary(dll_Kernel)
CloseLibrary(dll7zip)
; IDE Options = PureBasic 4.61 (Windows - x86)
; CursorPosition = 1187
; FirstLine = 951
; Folding = HAIz6P9
; EnableThread
; EnableXP
; UseIcon = icon.ico
; Executable = naMCl.exe
; IncludeVersionInfo
; VersionField0 = 0.12.8.7
; VersionField1 = 0.12.8.7
; VersionField2 = GPI
; VersionField3 = NAMCL
; VersionField4 = 0.12.8.7
; VersionField5 = 0.12.8.7
; VersionField6 = Not Another Minecraft Launcher
; VersionField7 = NAMCL
; VersionField8 = NAMCL.EXE