UseJPEGImageDecoder()
UseJPEG2000ImageDecoder()
UsePNGImageDecoder()
UseTGAImageDecoder()

UsePNGImageEncoder()



file$=OpenFileRequester("Select Terrain.png","terrain.png","PNG|*.png|ALL|*.*",0)
If file$=""
  End
EndIf
Global prefix.s="icons\Spax32_"
prefix=InputRequester("EnterPrefix","Please enter a prefix",prefix)

If prefix=""
  End
EndIf


Global Dim img(2,100,100)


Procedure grabimg(img,x,y,newimg,w,h)
  StartDrawing(ImageOutput(newimg))
  DrawImage(ImageID(img),-x*w,-y*w)
  StopDrawing()
  SaveImage(newimg,prefix+Str(x+y*16)+".png",#PB_ImagePlugin_PNG )
EndProcedure
Procedure getpixels(d,xx,yy,w,h)
  For x=0 To w-1
    For y=0 To h-1
      img(d,x,y)=Point(x+xx*w,y+yy*h)
      ;Debug Str(x)+Str(y)
    Next
  Next
EndProcedure
Procedure ReduceRGB(x,re.f)
  r=Int(Red(x)*re)
  g=Int(Green(x)*re)
  b=Int(Blue(x)*re)
  ProcedureReturn RGB(r,g,b)
EndProcedure
Procedure Boxit(img,x1,y1,x2,y2,x3,y3,w,h,newimg,file.s)
  StartDrawing(ImageOutput(img))
      getpixels(0,x1,y1,w,h)
      getpixels(1,x2,y2,w,h)
      getpixels(2,x3,y3,w,h)  
      StopDrawing()
  StartDrawing(ImageOutput(newimg))
  Box(0,0,w*2,h*2,$ffffff)
  For x=0 To w-1
    For y=0 To h-1
      Plot(x    ,y+x/2+w/2,ReduceRGB(img(0,x,y),0.9) )
      Plot(x+w-1,y+(w-x-1)/2 +w/2     ,ReduceRGB(img(1,x,y),0.8))
      If x<w-1 
        LineXY(w-1-x+y , h-1-x/2-y/2,w-1-x-1+y , h-1-(x+1)/2-y/2 ,img(2,x,y))
      EndIf
      If y<h-1
        LineXY(w-1-x+y , h-1-x/2-y/2,w-1-x+y+1 , h-1-x/2-(y+1)/2 ,img(2,x,y))
      EndIf
      If x<w-1 And y<h-1
        LineXY(w-1-x+y , h-1-x/2-y/2,w-1-x-1+y+1 , h-1-(x+1)/2-(y+1)/2 ,img(2,x,y))
      EndIf
        ;Plot (w-1-x+y , h-1-x/2-y/2 ,img(2,x,y))
    Next
  Next
  StopDrawing()
  ;Debug file
  SaveImage(newimg,file,#PB_ImagePlugin_PNG)
EndProcedure
  

img=LoadImage(#PB_Any,file$)

If img
  w=ImageWidth(img)/16:h=ImageWidth(img)/16
  
  newimg=CreateImage(#PB_Any,w*2,h*2)
  
  boxit(img,3,0,3,0,2,9,w,h,newimg,prefix+"b_gras.png")
  boxit(img,8,0,8,0,9,0,w,h,newimg,prefix+"b_dyna.png")
  boxit(img,4,1,4,1,5,1,w,h,newimg,prefix+"b_wood.png")
  boxit(img,4,7,4,7,5,1,w,h,newimg,prefix+"b_wood2.png")
  boxit(img,5,7,5,7,5,1,w,h,newimg,prefix+"b_wood3.png")
  boxit(img,9,9,9,9,5,1,w,h,newimg,prefix+"b_wood4.png")
  boxit(img,10,1,11,1,9,1,w,h,newimg,prefix+"b_box.png")
  boxit(img,3,2,3,2,4,0,w,h,newimg,prefix+"b_book.png")
  boxit(img,12,2,13,2,14,3,w,h,newimg,prefix+"b_furoff.png")
  boxit(img,13,3,13,2,14,3,w,h,newimg,prefix+"b_furon.png")
  boxit(img,14,2,13,2,14,3,w,h,newimg,prefix+"b_dis.png")
  boxit(img,10,4,10,4,11,4,w,h,newimg,prefix+"b_music.png")
  boxit(img,13,4,13,4,14,4,w,h,newimg,prefix+"b_mod.png")
  boxit(img,12,6,12,6,11,6,w,h,newimg,prefix+"b_push.png")
  boxit(img,12,6,12,6,10,6,w,h,newimg,prefix+"b_push2.png")
  boxit(img,6,7,6,7,6,6,w,h,newimg,prefix+"b_kur.png")
  boxit(img,7,7,6,7,6,6,w,h,newimg,prefix+"b_kur1.png")
  boxit(img,8,7,6,7,6,6,w,h,newimg,prefix+"b_kur2.png")
  boxit(img,8,8,8,8,9,8,w,h,newimg,prefix+"b_kur3.png")
  boxit(img,11,3,12,3,11,2,w,h,newimg,prefix+"b_tool.png")

  For xx=0 To 15
    For yy=0 To 15
      boxit(img,xx,yy,xx,yy,xx,yy,w,h,newimg,prefix+"B"+Str(xx+yy*16)+".png")
    Next
  Next
  
  FreeImage(newimg)
  
  newimg=CreateImage(#PB_Any,w,h)
  
  If newimg
    For x=0 To 15
      For y=0 To 15
        StartDrawing(ImageOutput(newimg))
        DrawImage(ImageID(img),-x*w,-y*w)
        StopDrawing()
        SaveImage(newimg,prefix+Str(x+y*16)+".png",#PB_ImagePlugin_PNG )
      Next
    Next
  
  EndIf
  
EndIf
; IDE Options = PureBasic 4.61 (Windows - x86)
; CursorPosition = 17
; Folding = -
; EnableXP