Procedure GetLogin(parentwin,*login.login)
  DisableWindow(parentwin,#True)
  win_login=OpenWindow(#PB_Any,0,0,300,5+20+5+20+10+20+5+5,"MineCraft Login",#PB_Window_WindowCentered,WindowID(parentwin))
  
  TextGadget(#PB_Any,    5, 5,   50,20,"Name:")
  gad_name=StringGadget(#PB_Any, 55, 5,  240,20,*login\name)
  TextGadget(#PB_Any,    5,35,   50,20,"Password:")
  gad_pass=StringGadget(#PB_Any, 55,35,  240,20,*login\pass,#PB_String_Password)
  
  gad_ok=ButtonGadget(#PB_Any, 150-102,65,100,20,"Login")
  gad_cancel=ButtonGadget(#PB_Any, 150+2  ,65,100,20,"Cancel")
  
  If *login\name<>""
    SetActiveGadget(gad_pass)
  Else
    SetActiveGadget(gad_name)
  EndIf
  AddKeyboardShortcut(win_login,#PB_Shortcut_Return,#menu_ok)
  AddKeyboardShortcut(win_login,#PB_Shortcut_Escape,#menu_cancel)
  
  Repeat
    event=WaitWindowEvent()
    Select event
      Case #PB_Event_CloseWindow
        ok=#False
        Break
      Case #PB_Event_Menu
        Select EventMenu()
          Case #menu_ok
            ok=#True
            Break
          Case #menu_cancel
            ok=#False
            Break
        EndSelect
      Case #PB_Event_Gadget
        If EventType()=#PB_EventType_LeftClick
          Select EventGadget()
            Case gad_ok
              ok=#True
              Break
            Case gad_cancel
              ok=#False
              Break
          EndSelect
        EndIf
    EndSelect
  ForEver
  If ok
    *login\name=GetGadgetText(gad_name)
    *login\pass=GetGadgetText(gad_pass)
  EndIf
  CloseWindow(win_login)
  
  DisableWindow(parentwin,#False)
  ProcedureReturn ok
EndProcedure
Procedure GetSession(*login.login,*logdat.login)
  ;Debug "GEtSession"
  tempfile.s=GetTemporaryDirectory()+#title+Str(Date())
  
  url$=MCLOGINURL
  url$=ReplaceString(url$,"%1%",URLEncoder(*login\name))
  url$=ReplaceString(url$,"%2%",URLEncoder(*login\pass))
  url$=ReplaceString(url$,"%3%",MCLOGINVER)

  If IEGetFile(url$,tempfile)
    in=ReadFile(#PB_Any,tempfile)
    If in
      b$=ReadString(in)
      ;Debug "session:"+b$
      If FindString(b$,":")=0
        *logdat\name=b$
      Else
        *logdat\name=StringField(b$,3,":")
        *logdat\pass=StringField(b$,4,":")
      EndIf
      
      CloseFile(in)
    EndIf
  EndIf
  DeleteFile(tempfile)
  ProcedureReturn FindString(b$,":")
EndProcedure
;- MCFileList-Routinen
Procedure GetMCFileList(url$,CDir.s)
  MCFileListCache=cachedir+cdir
  tempfile.s=cachedir+Left(cdir,Len(cdir)-1)+"-index.xml"
  ClearList(MCFilelist())  
  
  
  If GetFileDate(tempfile,#PB_Date_Modified)<Date()-60*60 Or FileSize(tempfile)<=0
    If IEGetFile(url$,tempfile)=0
      addmessage("GetMCFileList: Can't download "+url$)
      ProcedureReturn 0
    EndIf
  EndIf    
  
  ;Datei auslesen  
  in=ReadFile(#PB_Any,tempfile)
  If in
    While Not Eof(in)
      a$=ReadString(in)
      key=0
      Repeat
        key$=FindKey(a$,"Contents",@key)
        If key
          file$=findkey(key$,"Key")
          
          date=ParseDate("%yyyy-%mm-%ddT%hh:%ii:%ss",findkey(Key$,"LastModified"))
          md5$=ReplaceString(findkey(Key$,"ETag"),"&quot;","")      
          size=Val(findkey(Key$,"Size"))
          If Right(file$,1)="/"
            ;Ordner interssieren nicht
          Else
            Localfile$=ReplaceString(file$,"/","\")
            AddElement(MCFilelist())
            MCFilelist()\date=date
            MCFilelist()\md5=md5$
            MCFilelist()\url=url$+URLEncoder(file$)
            MCFilelist()\file=ReplaceString(file$,"/","\")
            MCFilelist()\size=size
          EndIf
          ;
        EndIf
      Until key=0
    Wend  
    CloseFile(in)
  Else
    addmessage("GetMCFileList:Can't open "+tempfile)
    ProcedureReturn 0
  EndIf
  
  ProcedureReturn ListSize(MCFilelist())
EndProcedure
Procedure FindMCFile(Search$)
  search$=UCase(Search$)
  ResetList(MCFilelist())
  ret=#False
  While NextElement(MCFilelist())
    If UCase(MCFilelist()\file)=Search$
      ret=#True
      Break
    EndIf
  Wend
  ProcedureReturn ret
EndProcedure
Procedure DownloadMCFile(Search$,LocalFile$="")
  If localfile$=""
    localfile$=search$
  Else
    If FindMCFile(Search$)=#False
      addmessage("DownloadMCFile: Can't find "+search$)
      ProcedureReturn #False
    EndIf
  EndIf
  
  doDownload=#True
  If FileSize(localfile$)=MCFilelist()\size
    If MD5FileFingerprint(Localfile$)=MCFilelist()\md5
      doDownload=#False
    EndIf
  EndIf
  If doDownload
    CacheFile.s=MCFileListCache+MCFilelist()\file
    doCopy=#False 
    If FileSize(CacheFile)=MCFilelist()\size
      If MD5FileFingerprint(CacheFile)=MCFilelist()\md5
        doCopy=#True
      EndIf
    EndIf
    
    If doCopy=#False
      Debug "ADD to Download"
      AddElement(DownloadList())
      downloadlist()\localfile=Localfile$
      downloadlist()\cachefile=CacheFile
      downloadlist()\size=MCFilelist()\size
      downloadlist()\date=mcfilelist()\date 
      DownloadList()\md5=MCFilelist()\md5
      DownloadList()\url=MCFilelist()\url  
      
    Else
      CreateTreeFile(LocalFile$)
      DeleteFile(LocalFile$)
      ret=CopyFile(CacheFile,LocalFile$)      
      If ret=0      
        addmessage("DownloadMCFile:Can't copy "+CacheFile+" to "+LocalFile$)
      EndIf
      SetFileDate(localfile$,#PB_Date_Modified,MCFilelist()\date)
    EndIf
  Else
    ret=#True
  EndIf
  ProcedureReturn ret
EndProcedure

Procedure CB_DoDownloads(*info.Filedownload)
  *info\result=IEGetFile(*info\url,*info\file)
  *info\finish=#True
EndProcedure
Procedure DoDownloads(gad_text=0,gad_time=0,gad_progress=0)
  SizeDownload=0
  ForEach downloadlist()
    SizeDownload+DownloadList()\size
  Next
  
  Debug Str(ListSize(DownloadList()))+" Files "+Str(SizeDownload)+" Bytes"
  SizeDone=0
  StartTime=ElapsedMilliseconds()
  oldprozent=-1
  
  ForEach DownloadList()
    If gad_text
      SetGadgetText(gad_text,GetFilePart(DownloadList()\localfile))
    Else
      Debug "Download "+GetFilePart(DownloadList()\localfile)+" ..."
    EndIf
    CreateTreeFile(downloadlist()\Cachefile)
    
    ;ret=ReceiveHTTPFile(downloadlist()\url,downloadlist()\Cachefile)
    info.filedownload
    info\url=downloadlist()\url
    info\file=downloadlist()\Cachefile
    DeleteFile(downloadlist()\Cachefile)
    info\finish=#False
    
    CreateThread(@CB_DoDownloads(),info)
    While info\finish=#False
      Delay(100)
      cursize=SizeDone+FileSize(downloadlist()\Cachefile)
      prozent=Int(cursize*100.0/SizeDownload)
      DeltaTime=ElapsedMilliseconds()-StartTime
      estTime.f=Deltatime*sizedownload/cursize
      eta=Int(estTime)
      If prozent<>oldprozent
        oldprozent=prozent
        If gad_time
          SetGadgetText(gad_time,Str(deltatime/1000/60)+":"+Right("0"+Str((deltatime/1000)%60),2)+ " ETA:"+Str(eta/1000/60)+":"+Right("0"+Str((eta/1000)%60),2) )
        EndIf    
        If gad_progress
          SetGadgetState(gad_progress,Int(prozent))
        Else
          Debug StrF(prozent,2)+"%"+" Time:"+StrF(deltatime/60000,2)+" Est:"+StrF(estTime/60000,2) 
        EndIf
      EndIf
    Wend
    ret=info\result
    
    If ret
      SetFileDate(downloadlist()\Cachefile,#PB_Date_Modified,downloadlist()\date)
    Else
      addmessage("DoDownloads:Can't download "+downloadlist()\url+" to "+downloadlist()\cachefile)
      ProcedureReturn #False
    EndIf
    doCopy=#False
    If FileSize(downloadlist()\CacheFile)=downloadlist()\size
      If MD5FileFingerprint(downloadlist()\CacheFile)=downloadlist()\md5
        doCopy=#True
      EndIf
    EndIf
    If doCopy
      CreateTreeFile(downloadlist()\LocalFile)
      DeleteFile(downloadlist()\LocalFile)
      ret=CopyFile(downloadlist()\CacheFile,downloadlist()\LocalFile)      
      If ret=0      
        addmessage("DoDownloads:Can't copy "+downloadlist()\CacheFile+" to "+downloadlist()\LocalFile)
      EndIf
      SetFileDate(downloadlist()\localfile,#PB_Date_Modified,downloadlist()\date)
    Else
      addmessage("DoDownloads: Corrupt Download "+downloadlist()\url)
      ProcedureReturn #False
    EndIf
    
    sizedone+DownloadList()\size  
    ;prozent.f=SizeDone*100.0/SizeDownload
    ;DeltaTime=ElapsedMilliseconds()-StartTime
    ;estTime.f=Deltatime*sizedownload/sizedone
    ;eta=Int(estTime)
    ;Debug "done - "+StrF(prozent,2)+"%"+" Time:"+StrF(deltatime/60000,2)+" Est:"+StrF(estTime/60000,2)
    ;If gad_time
    ;  SetGadgetText(gad_time,Str(deltatime/1000/60)+":"+Right("0"+Str((deltatime/1000)%60),2)+ " ETA:"+Str(eta/1000/60)+":"+Right("0"+Str((eta/1000)%60),2) )
    ;EndIf    
    ;If gad_progress
    ;  SetGadgetState(gad_progress,Int(prozent))
    ;EndIf
  Next
  ClearList(downloadlist())
  ProcedureReturn #True 
EndProcedure

Procedure SaveVersion(file.s,version)
  out=CreateFile(#PB_Any,file)
  If out
    WriteByte(out,0)
    WriteByte(out,$d)
    WriteString(out,Str(version)+"000")
    CloseFile(out)
    ProcedureReturn #True
  Else
    addmessage("SaveVersion: Can't create version-file "+file)
    ProcedureReturn #False
  EndIf
EndProcedure

Procedure DownloadMinecraft(InsName.s,forced,beta.s=#Server_Release,gad_text=0,gad_time=0,gad_progress=0)
  ClearList(downloadlist())
  
  ;Spieldateien erstellen
  If GetMCFileList(MCURL,"download\")
    
    MCDir.s=InstancesDir+InsName+"\.minecraft\"
    
    CreateTreeFile(mcdir)
    CreateDirectory(mcdir+"saves")
    CreateDirectory(mcdir+"screenshots")
    CreateDirectory(mcdir+"stats")
    CreateDirectory(mcdir+"texturepacks")
    CreateDirectory(mcdir+"bin")
    CreateDirectory(mcdir+"resources")
    
    ;*** BIN-Pfad downloaden vorbereiten
    
    If FileSize(mcdir+"bin\jinput.jar")<=0 Or forced            : DownloadMCFile("jinput.jar",mcdir+"bin\jinput.jar") : EndIf
    If FileSize(mcdir+"bin\lwjgl.jar")<=0 Or forced             : DownloadMCFile("lwjgl.jar",mcdir+"bin\lwjgl.jar") : EndIf
    If FileSize(mcdir+"bin\lwjgl_util.jar")<=0 Or forced        : DownloadMCFile("lwjgl_util.jar",mcdir+"bin\lwjgl_util.jar") : EndIf
    If FileSize(mcdir+"bin\windows_natives.jar")<=0 Or forced   : DownloadMCFile("windows_natives.jar.lzma",mcdir+"bin\windows_natives.jar.lzma") : EndIf
    If FileSize(mcdir+"bin\MinecraftLauncher.jar")<=0 Or forced : DownloadMCFile("launcher\MinecraftLauncher.jar",mcdir+"bin\MinecraftLauncher.jar") : EndIf
    If FindMCFile("minecraft.jar")
      minecraftDate=MCFilelist()\date
    EndIf
    
    ;minecraftjar immer downloaden
    If beta=#Server_Beta
      If GetMCFileList(MCASSETSURL,"assets\")
        minecraftjar.s="":maxDate=0
        ForEach mcfilelist()
          If Right(UCase("\"+mcfilelist()\file),14)="\MINECRAFT.JAR" And mcfilelist()\date>maxDate
            minecraftjar=mcfilelist()\file
            maxDate=MCFilelist()\date
          EndIf
        Next
        If maxDate  
          DownloadMCFile(minecraftjar,mcdir+"bin\minecraft.jar")
        Else
          addmessage("DownloadMinecraft: Can't find Beta.jar")
          ProcedureReturn #False
        EndIf
        
      Else
        addmessage("DownloadMinecraft: Can't download assets-file-list")
        ProcedureReturn #False
      EndIf
      
    ElseIf beta=#server_release
      DownloadMCFile("minecraft.jar",mcdir+"bin\minecraft.jar")
    Else
      a=CopyFile(VersionsDir+beta,mcdir+"bin\minecraft.jar")
      If a=#False
        addmessage("DownloadMinecraft: Can't copy "+beta)
      EndIf
    EndIf    
    
    ;*** Resourcen downloaden vorbereiten
    
    If GetMCFileList(MCRESURL,"resources\")
      ForEach MCFilelist()
        If FileSize(mcdir+"resources\"+MCFilelist()\file)<=0 Or forced : DownloadMCFile(mcdir+"resources\"+MCFilelist()\file) : EndIf        
      Next
    Else
      addmessage("DownloadMinecraft: Can't download resources-file-list")
      ProcedureReturn #False
    EndIf
    
    ; *** Tatschlich downloaden
    
    If DoDownloads(gad_text,gad_time,gad_progress)=#False
      addmessage("DownloadMinecraft:Can't download!")
      ProcedureReturn #False
    EndIf
        
    ;### Bin-Ordner vorbereiten
    
    SetCurrentDirectory(mcdir+"bin")
    
    ;*** natives entpacken
    
    cmd$="x windows_natives.jar.lzma -aoa -hide -xr!meta-inf"
    x=GetActiveWindow()
    If x=0
      x=mainwindow
    EndIf
    ret=SevenZip(WindowID(x), @cmd$, 0,0)
    If ret
      addmessage("DownloadMinecraft: Can't unzip natives.lzma")
      SetCurrentDirectory(CurrentDir)
      ProcedureReturn #False
    EndIf
    
    cmd$="x -tzip windows_natives.jar -aoa -onatives -hide -xr!meta-inf"
    x=GetActiveWindow()
    If x=0
      x=mainwindow
    EndIf
    ret=SevenZip(WindowID(x), @cmd$, 0,0)
    If ret
      addmessage("DownloadMinecraft: Can't unzip natives.jar")
      SetCurrentDirectory(CurrentDir)
      ProcedureReturn #False
    EndIf
    
    ;*** Version-String schreiben
    
    If SaveVersion("version",minecraftdate)=#False
      SetCurrentDirectory(CurrentDir)
      ProcedureReturn #False
    EndIf
    
    
    ;*** MD5-Datei schreiben
    out=CreateFile(#PB_Any,"md5s")
    If out
      WriteStringN(out,"#md5 hashes for downloaded files")
      WriteStringN(out,"#")
      WriteStringN(out,"lwjgl.jar="+MD5FileFingerprint("lwjgl.jar"))
      WriteStringN(out,"jinput.jar="+MD5FileFingerprint("jinput.jar"))
      WriteStringN(out,"windows_natives.jar="+MD5FileFingerprint("windows_natives.jar"))
      WriteStringN(out,"lwjgl_util.jar="+MD5FileFingerprint("lwjgl_util.jar"))
      WriteStringN(out,"minecraft.jar="+MD5FileFingerprint("minecraft.jar"))
      CloseFile(out)
    Else
      addmessage("DownloadMinecraft: Can't create md5s-file")
      SetCurrentDirectory(CurrentDir)
      ProcedureReturn #False
    EndIf
    
    ;### Bin-Folder vorbereitet
    
    SetCurrentDirectory(CurrentDir)
    
    
    
    
    ProcedureReturn #True
  Else
    addmessage("DownloadMinecraft: Can't download download-file-list")
    ProcedureReturn #False
  EndIf
  
EndProcedure

Procedure StartMinecraft(*settings.instances)
  If MineCraftID
    addmessage("StartMinecraft: Minecraft already run")
    ProcedureReturn #False
  EndIf
  If *settings\AutoBackupSaves
    SaveBackup(*settings)
  EndIf
  InsName.s=*settings\path
  MCDir.s=InstancesDir+InsName
  
  SetEnvironmentVariable("APPDATA",mcdir)
  Select *settings\uselauncher
    Case #launcher_alt
      cmd$="-jar "+*settings\altlauncher
      path$=GetPathPart(*settings\altlauncher)
    Case #launcher_mc
      cmd$="-cp MinecraftLauncher.jar net.minecraft.LauncherFrame"
      path$=mcdir+"\.minecraft\bin"
    Case #launcher_int
      ret=#True
      If *settings\LoginCrypt
        DeCryptPass(*settings\LoginCrypt,login.login)
      Else
        If getlogin(MainWindow,login)=#False
          ret=#False
        EndIf        
      EndIf
      If ret
        If login\name<>""
          Repeat
            If GetSession(login,logdat.login)
              Break
            Else
              MessageRequester(#title,logdat\name)
              If GetLogin(MainWindow,login)=#False
                ret=#False
                addmessage("StartMinecraft: Login canceld")
                Break
              EndIf
            EndIf
          ForEver
        EndIf
        
      EndIf
      If ret=#False
        ProcedureReturn #False
      EndIf
     
      path$=mcdir+"\.minecraft\bin"
      cmd$="-cp jinput.jar;lwjgl.jar;lwjgl_util.jar;minecraft.jar "
      cmd$+Chr(34)+"-Dorg.lwjgl.librarypath=" +path$+"\natives"+ Chr(34)+" "
      cmd$+Chr(34)+"-Dnet.java.games.input.librarypath=" +path$+"\natives"+ Chr(34)+" "
      cmd$+"net.minecraft.client.Minecraft "+logdat\name+" "+logdat\pass
      If *settings\autoconnect
        cmd$+" "+*settings\connectip
      EndIf
      
      Debug cmd$
      ; D:\purebasic\Minecraft\Instances\4FF60DE2 - 1_2_5\.minecraft\bin>java -cp jinput
      ; .jar;lwjgl.jar;lwjgl_util.jar;minecraft.jar "-Dorg.lwjgl.librarypath=D:\purebasi
; c\Minecraft\Instances\4FF848B4 - current\.minecraft\bin/natives" "-Dnet.java.gam
; es.input.librarypath=D:\purebasic\Minecraft\Instances\4FF848B4 - current\.minecr
; aft\bin/natives" "-Duser.home=D:\purebasic\Minecraft\Instances\4FF848B4 - curren
; t" net.minecraft.client.Minecraft GePeIe 791203292161519421
        
  EndSelect
  
  If *settings\setmemory
    cmd$="-Xmx"+Str(*settings\maxmemory)+"m -Xms"+Str(*settings\minmemory)+"m "+cmd$
  EndIf
  
  If *settings\customjava
    java$=*settings\javapath+"javaw.exe"
  Else
    java$=GetJavaPath()+"javaw.exe"
  EndIf
  
  MineCraftID=RunProgram(java$,cmd$,path$,#PB_Program_Open);|#PB_Program_Read)
  If minecraftid=0
    addmessage("StartMinecraft: Can't start Java")
    ProcedureReturn #False
  EndIf
;    While ProgramRunning(MineCraftID)
;       If AvailableProgramOutput(MineCraftID)
;         Output$ + ReadProgramString(MineCraftID) + Chr(13)
;       EndIf
;     Wend
;     Output$ + Chr(13) + Chr(13)
;     Output$ + "Exitcode: " + Str(ProgramExitCode(MineCraftID))     
;     
;     CloseProgram(MineCraftID)
;   
;   MessageRequester("Output", Output$)

  
  
  ;Debug FileSize("minecraftlauncher.jar")
  ;SetCurrentDirectory(cur$)
  
  MineCraftCheckID=2
  *MineCraftInstance=*settings
  ProcedureReturn MineCraftID
EndProcedure
Procedure CheckMinecraft()
  If MineCraftID
    doresize=*minecraftInstance\maximize
    If ProgramRunning(MineCraftID)
      If MineCraftCheckID
        handle=FindWindow_(MCWINClass,MCWIName)
        
        If handle
          Select DoResize
            Case 0
              
            Case 1;Maximieren
              Delay(200)
              ShowWindow_(handle,#SW_MAXIMIZE)
              Debug "Resize!"
            Case 2;Grennderung
              GetWindowRect_(GetDesktopWindow_(),rect.RECT)
              Width=rect\right
              Height=rect\bottom
              SystemParametersInfo_(#SPI_GETWORKAREA,0,rect.RECT,0) 
              WX=rect\left:WY=rect\top
              WW=rect\right-rect\left:WH=rect\bottom-rect\top
              
           
              x=(ww-wx-w)/2
              y=(wh-wy-h)/2
              #SWP_ASYNCWINDOWPOS  = $4000
              SetWindowPos_(handle,0,X,Y,W,H,#SWP_ASYNCWINDOWPOS|#SWP_NOOWNERZORDER)
              ;
            Case 2
          EndSelect
          
          MineCraftCheckID=#False
        EndIf
      EndIf
    Else
      CloseProgram(MineCraftID)
      MineCraftID=0
      MineCraftCheckID=#False      
    EndIf
  EndIf
EndProcedure

; IDE Options = PureBasic 4.61 (Windows - x86)
; CursorPosition = 392
; Folding = --
; EnableXP
; UseMainFile = StartMinecraft.pb